
module MenhirBasics = struct
  
  exception Error = Parsing.Parse_error
  
  let _eRR =
    fun _s ->
      raise Error
  
  type token = 
    | XOR
    | XCHG
    | WHILE
    | WCAS_EXPLICIT
    | WCAS
    | VOLATILE
    | VOID
    | UNLOCK
    | UNDERFENCE
    | UNDERATOMICOPRETURN
    | UNDERATOMICOP
    | UNDERATOMICFETCHOP
    | UNDERATOMICADDUNLESS
    | SUB
    | ST_EXPLICIT
    | STRUCT_TYPE of (
# 29 "lib/CParser.mly"
       (string)
# 30 "lib/CParser.ml"
  )
    | STRUCT
    | STORE
    | STAR
    | SRCU
    | SPINUNLOCK
    | SPINTRYLOCK
    | SPINLOCK
    | SPINISLOCKED
    | SEMI
    | SCOPES
    | SCAS_EXPLICIT
    | SCAS
    | RPAR
    | REGIONS
    | RBRACE
    | PROC of (
# 33 "lib/CParser.mly"
       (int)
# 50 "lib/CParser.ml"
  )
    | PIPE
    | NUM of (
# 43 "lib/CParser.mly"
       (int)
# 56 "lib/CParser.ml"
  )
    | NEQ_OP
    | NAME of (
# 27 "lib/CParser.mly"
       (string)
# 62 "lib/CParser.ml"
  )
    | MUTEX
    | MEMORDER of (
# 60 "lib/CParser.mly"
       (MemOrder.t)
# 68 "lib/CParser.ml"
  )
    | LT
    | LPAR
    | LONG
    | LOCK
    | LOAD
    | LEVELS
    | LE
    | LD_EXPLICIT
    | LBRACE
    | LAND
    | INT
    | IF
    | GT
    | GE
    | FENCE
    | EXC_EXPLICIT
    | EQ_OP
    | EQ
    | EOF
    | ELSE
    | DIV
    | CONSTVAR of (
# 31 "lib/CParser.mly"
       (string)
# 94 "lib/CParser.ml"
  )
    | CONSTANT of (
# 51 "lib/CParser.mly"
       (string)
# 99 "lib/CParser.ml"
  )
    | CONST
    | COMMA
    | COLON
    | CODEVAR of (
# 32 "lib/CParser.mly"
       (string)
# 107 "lib/CParser.ml"
  )
    | CMPXCHG
    | CHAR
    | BODY of (
# 46 "lib/CParser.mly"
       (string)
# 114 "lib/CParser.ml"
  )
    | BASE_TYPE of (
# 28 "lib/CParser.mly"
       (string)
# 119 "lib/CParser.ml"
  )
    | ATOMIC_TYPE of (
# 30 "lib/CParser.mly"
       (string)
# 124 "lib/CParser.ml"
  )
    | ATOMIC_FETCH_EXPLICIT of (
# 65 "lib/CParser.mly"
       (CBase.op)
# 129 "lib/CParser.ml"
  )
    | ATOMIC_BASE
    | ATOMICADDUNLESS
    | ATOMIC
    | ADD
  
end

include MenhirBasics

# 1 "lib/BellExtraRules.mly"
  
(****************************************************************************)
(*                           the diy toolsuite                              *)
(*                                                                          *)
(* Jade Alglave, University College London, UK.                             *)
(* Luc Maranget, INRIA Paris-Rocquencourt, France.                          *)
(*                                                                          *)
(* Copyright 2015-present Institut National de Recherche en Informatique et *)
(* en Automatique and the authors. All rights reserved.                     *)
(*                                                                          *)
(* This software is governed by the CeCILL-B license under French law and   *)
(* abiding by the rules of distribution of free software. You can use,      *)
(* modify and/ or redistribute the software under the terms of the CeCILL-B *)
(* license as circulated by CEA, CNRS and INRIA at the following URL        *)
(* "http://www.cecill.info". We also give a copy in LICENSE.txt.            *)
(****************************************************************************)
open BellInfo
let nones = { scopes=None; levels=None; regions=None; }

# 160 "lib/CParser.ml"

# 1 "lib/CParser.mly"
  
(****************************************************************************)
(*                           the diy toolsuite                              *)
(*                                                                          *)
(* Jade Alglave, University College London, UK.                             *)
(* Luc Maranget, INRIA Paris-Rocquencourt, France.                          *)
(*                                                                          *)
(* Copyright 2015-present Institut National de Recherche en Informatique et *)
(* en Automatique and the authors. All rights reserved.                     *)
(*                                                                          *)
(* This software is governed by the CeCILL-B license under French law and   *)
(* abiding by the rules of distribution of free software. You can use,      *)
(* modify and/ or redistribute the software under the terms of the CeCILL-B *)
(* license as circulated by CEA, CNRS and INRIA at the following URL        *)
(* "http://www.cecill.info". We also give a copy in LICENSE.txt.            *)
(****************************************************************************)

let mk_sym s = Constant.mk_sym s

open CBase
open MemOrder
open CType
open MemOrderOrAnnot

# 187 "lib/CParser.ml"

# 1 "lib/scopeRules.mly"
  
(****************************************************************************)
(*                           the diy toolsuite                              *)
(*                                                                          *)
(* Jade Alglave, University College London, UK.                             *)
(* Luc Maranget, INRIA Paris-Rocquencourt, France.                          *)
(*                                                                          *)
(* Copyright 2019-present Institut National de Recherche en Informatique et *)
(* en Automatique and the authors. All rights reserved.                     *)
(*                                                                          *)
(* This software is governed by the CeCILL-B license under French law and   *)
(* abiding by the rules of distribution of free software. You can use,      *)
(* modify and/ or redistribute the software under the terms of the CeCILL-B *)
(* license as circulated by CEA, CNRS and INRIA at the following URL        *)
(* "http://www.cecill.info". We also give a copy in LICENSE.txt.            *)
(****************************************************************************)

# 207 "lib/CParser.ml"

type ('s, 'r) _menhir_state = 
  | MenhirState000 : ('s, _menhir_box_deep_main) _menhir_state
    (** State 000.
        Stack shape : .
        Start symbol: deep_main. *)

  | MenhirState005 : (('s, _menhir_box_deep_main) _menhir_cell1_voidopt _menhir_cell0_PROC, _menhir_box_deep_main) _menhir_state
    (** State 005.
        Stack shape : voidopt PROC.
        Start symbol: deep_main. *)

  | MenhirState006 : (('s, 'r) _menhir_cell1_VOLATILE, 'r) _menhir_state
    (** State 006.
        Stack shape : VOLATILE.
        Start symbol: <undetermined>. *)

  | MenhirState009 : (('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 009.
        Stack shape : LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState011 : (('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 011.
        Stack shape : LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState012 : (('s, 'r) _menhir_cell1_CONST, 'r) _menhir_state
    (** State 012.
        Stack shape : CONST.
        Start symbol: <undetermined>. *)

  | MenhirState026 : (('s, 'r) _menhir_cell1_ATOMIC, 'r) _menhir_state
    (** State 026.
        Stack shape : ATOMIC.
        Start symbol: <undetermined>. *)

  | MenhirState046 : ((('s, _menhir_box_deep_main) _menhir_cell1_voidopt _menhir_cell0_PROC, _menhir_box_deep_main) _menhir_cell1_parameter_list, _menhir_box_deep_main) _menhir_state
    (** State 046.
        Stack shape : voidopt PROC parameter_list.
        Start symbol: deep_main. *)

  | MenhirState048 : (('s, 'r) _menhir_cell1_XCHG, 'r) _menhir_state
    (** State 048.
        Stack shape : XCHG.
        Start symbol: <undetermined>. *)

  | MenhirState055 : ((('s, 'r) _menhir_cell1_XCHG, 'r) _menhir_cell1_annot_list, 'r) _menhir_state
    (** State 055.
        Stack shape : XCHG annot_list.
        Start symbol: <undetermined>. *)

  | MenhirState057 : (('s, 'r) _menhir_cell1_WCAS_EXPLICIT, 'r) _menhir_state
    (** State 057.
        Stack shape : WCAS_EXPLICIT.
        Start symbol: <undetermined>. *)

  | MenhirState059 : (('s, 'r) _menhir_cell1_WCAS, 'r) _menhir_state
    (** State 059.
        Stack shape : WCAS.
        Start symbol: <undetermined>. *)

  | MenhirState061 : (('s, 'r) _menhir_cell1_UNDERATOMICOPRETURN, 'r) _menhir_state
    (** State 061.
        Stack shape : UNDERATOMICOPRETURN.
        Start symbol: <undetermined>. *)

  | MenhirState064 : ((('s, 'r) _menhir_cell1_UNDERATOMICOPRETURN, 'r) _menhir_cell1_annot_list, 'r) _menhir_state
    (** State 064.
        Stack shape : UNDERATOMICOPRETURN annot_list.
        Start symbol: <undetermined>. *)

  | MenhirState066 : (('s, 'r) _menhir_cell1_UNDERATOMICFETCHOP, 'r) _menhir_state
    (** State 066.
        Stack shape : UNDERATOMICFETCHOP.
        Start symbol: <undetermined>. *)

  | MenhirState069 : ((('s, 'r) _menhir_cell1_UNDERATOMICFETCHOP, 'r) _menhir_cell1_annot_list, 'r) _menhir_state
    (** State 069.
        Stack shape : UNDERATOMICFETCHOP annot_list.
        Start symbol: <undetermined>. *)

  | MenhirState071 : (('s, 'r) _menhir_cell1_UNDERATOMICADDUNLESS, 'r) _menhir_state
    (** State 071.
        Stack shape : UNDERATOMICADDUNLESS.
        Start symbol: <undetermined>. *)

  | MenhirState072 : (('s, 'r) _menhir_cell1_STAR, 'r) _menhir_state
    (** State 072.
        Stack shape : STAR.
        Start symbol: <undetermined>. *)

  | MenhirState074 : ((('s, 'r) _menhir_cell1_STAR, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 074.
        Stack shape : STAR LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState076 : (('s, 'r) _menhir_cell1_SRCU, 'r) _menhir_state
    (** State 076.
        Stack shape : SRCU.
        Start symbol: <undetermined>. *)

  | MenhirState079 : ((('s, 'r) _menhir_cell1_SRCU, 'r) _menhir_cell1_annot_list, 'r) _menhir_state
    (** State 079.
        Stack shape : SRCU annot_list.
        Start symbol: <undetermined>. *)

  | MenhirState081 : (('s, 'r) _menhir_cell1_SPINTRYLOCK, 'r) _menhir_state
    (** State 081.
        Stack shape : SPINTRYLOCK.
        Start symbol: <undetermined>. *)

  | MenhirState083 : (('s, 'r) _menhir_cell1_SPINISLOCKED, 'r) _menhir_state
    (** State 083.
        Stack shape : SPINISLOCKED.
        Start symbol: <undetermined>. *)

  | MenhirState085 : (('s, 'r) _menhir_cell1_SCAS_EXPLICIT, 'r) _menhir_state
    (** State 085.
        Stack shape : SCAS_EXPLICIT.
        Start symbol: <undetermined>. *)

  | MenhirState087 : (('s, 'r) _menhir_cell1_SCAS, 'r) _menhir_state
    (** State 087.
        Stack shape : SCAS.
        Start symbol: <undetermined>. *)

  | MenhirState089 : (('s, 'r) _menhir_cell1_NAME, 'r) _menhir_state
    (** State 089.
        Stack shape : NAME.
        Start symbol: <undetermined>. *)

  | MenhirState090 : (('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 090.
        Stack shape : LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState091 : ((('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 091.
        Stack shape : LPAR LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState093 : (('s, 'r) _menhir_cell1_LOAD, 'r) _menhir_state
    (** State 093.
        Stack shape : LOAD.
        Start symbol: <undetermined>. *)

  | MenhirState096 : ((('s, 'r) _menhir_cell1_LOAD, 'r) _menhir_cell1_annot_list, 'r) _menhir_state
    (** State 096.
        Stack shape : LOAD annot_list.
        Start symbol: <undetermined>. *)

  | MenhirState098 : (('s, 'r) _menhir_cell1_LD_EXPLICIT, 'r) _menhir_state
    (** State 098.
        Stack shape : LD_EXPLICIT.
        Start symbol: <undetermined>. *)

  | MenhirState100 : (('s, 'r) _menhir_cell1_EXC_EXPLICIT, 'r) _menhir_state
    (** State 100.
        Stack shape : EXC_EXPLICIT.
        Start symbol: <undetermined>. *)

  | MenhirState104 : (('s, 'r) _menhir_cell1_CMPXCHG, 'r) _menhir_state
    (** State 104.
        Stack shape : CMPXCHG.
        Start symbol: <undetermined>. *)

  | MenhirState107 : ((('s, 'r) _menhir_cell1_CMPXCHG, 'r) _menhir_cell1_annot_list, 'r) _menhir_state
    (** State 107.
        Stack shape : CMPXCHG annot_list.
        Start symbol: <undetermined>. *)

  | MenhirState109 : (('s, 'r) _menhir_cell1_ATOMIC_FETCH_EXPLICIT, 'r) _menhir_state
    (** State 109.
        Stack shape : ATOMIC_FETCH_EXPLICIT.
        Start symbol: <undetermined>. *)

  | MenhirState111 : (('s, 'r) _menhir_cell1_ATOMICADDUNLESS, 'r) _menhir_state
    (** State 111.
        Stack shape : ATOMICADDUNLESS.
        Start symbol: <undetermined>. *)

  | MenhirState115 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 115.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState117 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 117.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState119 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 119.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState121 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 121.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState123 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 123.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState125 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 125.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState127 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 127.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState129 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 129.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState131 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 131.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState133 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 133.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState135 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 135.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState137 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 137.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState139 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 139.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState141 : ((('s, 'r) _menhir_cell1_ATOMICADDUNLESS, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 141.
        Stack shape : ATOMICADDUNLESS expr.
        Start symbol: <undetermined>. *)

  | MenhirState143 : (((('s, 'r) _menhir_cell1_ATOMICADDUNLESS, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 143.
        Stack shape : ATOMICADDUNLESS expr expr.
        Start symbol: <undetermined>. *)

  | MenhirState147 : ((('s, 'r) _menhir_cell1_ATOMIC_FETCH_EXPLICIT, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 147.
        Stack shape : ATOMIC_FETCH_EXPLICIT expr.
        Start symbol: <undetermined>. *)

  | MenhirState153 : (((('s, 'r) _menhir_cell1_CMPXCHG, 'r) _menhir_cell1_annot_list, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 153.
        Stack shape : CMPXCHG annot_list expr.
        Start symbol: <undetermined>. *)

  | MenhirState155 : ((((('s, 'r) _menhir_cell1_CMPXCHG, 'r) _menhir_cell1_annot_list, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 155.
        Stack shape : CMPXCHG annot_list expr expr.
        Start symbol: <undetermined>. *)

  | MenhirState159 : (('s, 'r) _menhir_cell1_annot_base, 'r) _menhir_state
    (** State 159.
        Stack shape : annot_base.
        Start symbol: <undetermined>. *)

  | MenhirState162 : (('s, 'r) _menhir_cell1_annot, 'r) _menhir_state
    (** State 162.
        Stack shape : annot.
        Start symbol: <undetermined>. *)

  | MenhirState165 : ((('s, 'r) _menhir_cell1_EXC_EXPLICIT, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 165.
        Stack shape : EXC_EXPLICIT expr.
        Start symbol: <undetermined>. *)

  | MenhirState177 : ((('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_typ, 'r) _menhir_state
    (** State 177.
        Stack shape : LPAR typ.
        Start symbol: <undetermined>. *)

  | MenhirState182 : ((('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_typ, 'r) _menhir_state
    (** State 182.
        Stack shape : LPAR typ.
        Start symbol: <undetermined>. *)

  | MenhirState184 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 184.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState190 : ((('s, 'r) _menhir_cell1_SCAS, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 190.
        Stack shape : SCAS expr.
        Start symbol: <undetermined>. *)

  | MenhirState192 : (((('s, 'r) _menhir_cell1_SCAS, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 192.
        Stack shape : SCAS expr expr.
        Start symbol: <undetermined>. *)

  | MenhirState196 : ((('s, 'r) _menhir_cell1_SCAS_EXPLICIT, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 196.
        Stack shape : SCAS_EXPLICIT expr.
        Start symbol: <undetermined>. *)

  | MenhirState198 : (((('s, 'r) _menhir_cell1_SCAS_EXPLICIT, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 198.
        Stack shape : SCAS_EXPLICIT expr expr.
        Start symbol: <undetermined>. *)

  | MenhirState217 : ((('s, 'r) _menhir_cell1_UNDERATOMICADDUNLESS, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 217.
        Stack shape : UNDERATOMICADDUNLESS expr.
        Start symbol: <undetermined>. *)

  | MenhirState219 : (((('s, 'r) _menhir_cell1_UNDERATOMICADDUNLESS, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 219.
        Stack shape : UNDERATOMICADDUNLESS expr expr.
        Start symbol: <undetermined>. *)

  | MenhirState223 : (((('s, 'r) _menhir_cell1_UNDERATOMICFETCHOP, 'r) _menhir_cell1_annot_list, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 223.
        Stack shape : UNDERATOMICFETCHOP annot_list expr.
        Start symbol: <undetermined>. *)

  | MenhirState227 : ((((('s, 'r) _menhir_cell1_UNDERATOMICFETCHOP, 'r) _menhir_cell1_annot_list, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_atomic_op, 'r) _menhir_state
    (** State 227.
        Stack shape : UNDERATOMICFETCHOP annot_list expr atomic_op.
        Start symbol: <undetermined>. *)

  | MenhirState231 : (((('s, 'r) _menhir_cell1_UNDERATOMICOPRETURN, 'r) _menhir_cell1_annot_list, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 231.
        Stack shape : UNDERATOMICOPRETURN annot_list expr.
        Start symbol: <undetermined>. *)

  | MenhirState233 : ((((('s, 'r) _menhir_cell1_UNDERATOMICOPRETURN, 'r) _menhir_cell1_annot_list, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_atomic_op, 'r) _menhir_state
    (** State 233.
        Stack shape : UNDERATOMICOPRETURN annot_list expr atomic_op.
        Start symbol: <undetermined>. *)

  | MenhirState237 : ((('s, 'r) _menhir_cell1_WCAS, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 237.
        Stack shape : WCAS expr.
        Start symbol: <undetermined>. *)

  | MenhirState239 : (((('s, 'r) _menhir_cell1_WCAS, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 239.
        Stack shape : WCAS expr expr.
        Start symbol: <undetermined>. *)

  | MenhirState243 : ((('s, 'r) _menhir_cell1_WCAS_EXPLICIT, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 243.
        Stack shape : WCAS_EXPLICIT expr.
        Start symbol: <undetermined>. *)

  | MenhirState245 : (((('s, 'r) _menhir_cell1_WCAS_EXPLICIT, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 245.
        Stack shape : WCAS_EXPLICIT expr expr.
        Start symbol: <undetermined>. *)

  | MenhirState253 : (((('s, 'r) _menhir_cell1_XCHG, 'r) _menhir_cell1_annot_list, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 253.
        Stack shape : XCHG annot_list expr.
        Start symbol: <undetermined>. *)

  | MenhirState256 : (('s, 'r) _menhir_cell1_WHILE, 'r) _menhir_state
    (** State 256.
        Stack shape : WHILE.
        Start symbol: <undetermined>. *)

  | MenhirState257 : ((('s, 'r) _menhir_cell1_WHILE, 'r) _menhir_cell1_STAR, 'r) _menhir_state
    (** State 257.
        Stack shape : WHILE STAR.
        Start symbol: <undetermined>. *)

  | MenhirState259 : ((('s, 'r) _menhir_cell1_WHILE, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 259.
        Stack shape : WHILE LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState260 : ((('s, 'r) _menhir_cell1_WHILE, 'r) _menhir_cell1_expr0, 'r) _menhir_state
    (** State 260.
        Stack shape : WHILE expr0.
        Start symbol: <undetermined>. *)

  | MenhirState262 : (('s, 'r) _menhir_cell1_UNLOCK, 'r) _menhir_state
    (** State 262.
        Stack shape : UNLOCK.
        Start symbol: <undetermined>. *)

  | MenhirState267 : (('s, 'r) _menhir_cell1_UNDERFENCE, 'r) _menhir_state
    (** State 267.
        Stack shape : UNDERFENCE.
        Start symbol: <undetermined>. *)

  | MenhirState272 : (('s, 'r) _menhir_cell1_UNDERATOMICOP, 'r) _menhir_state
    (** State 272.
        Stack shape : UNDERATOMICOP.
        Start symbol: <undetermined>. *)

  | MenhirState274 : ((('s, 'r) _menhir_cell1_UNDERATOMICOP, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 274.
        Stack shape : UNDERATOMICOP expr.
        Start symbol: <undetermined>. *)

  | MenhirState276 : (((('s, 'r) _menhir_cell1_UNDERATOMICOP, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_atomic_op, 'r) _menhir_state
    (** State 276.
        Stack shape : UNDERATOMICOP expr atomic_op.
        Start symbol: <undetermined>. *)

  | MenhirState281 : (('s, 'r) _menhir_cell1_ST_EXPLICIT, 'r) _menhir_state
    (** State 281.
        Stack shape : ST_EXPLICIT.
        Start symbol: <undetermined>. *)

  | MenhirState283 : ((('s, 'r) _menhir_cell1_ST_EXPLICIT, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 283.
        Stack shape : ST_EXPLICIT expr.
        Start symbol: <undetermined>. *)

  | MenhirState290 : (('s, 'r) _menhir_cell1_STORE, 'r) _menhir_state
    (** State 290.
        Stack shape : STORE.
        Start symbol: <undetermined>. *)

  | MenhirState293 : ((('s, 'r) _menhir_cell1_STORE, 'r) _menhir_cell1_annot_list, 'r) _menhir_state
    (** State 293.
        Stack shape : STORE annot_list.
        Start symbol: <undetermined>. *)

  | MenhirState295 : (((('s, 'r) _menhir_cell1_STORE, 'r) _menhir_cell1_annot_list, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 295.
        Stack shape : STORE annot_list expr.
        Start symbol: <undetermined>. *)

  | MenhirState299 : (('s, 'r) _menhir_cell1_STAR, 'r) _menhir_state
    (** State 299.
        Stack shape : STAR.
        Start symbol: <undetermined>. *)

  | MenhirState300 : ((('s, 'r) _menhir_cell1_STAR, 'r) _menhir_cell1_STAR, 'r) _menhir_state
    (** State 300.
        Stack shape : STAR STAR.
        Start symbol: <undetermined>. *)

  | MenhirState302 : (((('s, 'r) _menhir_cell1_STAR, 'r) _menhir_cell1_STAR, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 302.
        Stack shape : STAR STAR LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState307 : ((('s, 'r) _menhir_cell1_STAR, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 307.
        Stack shape : STAR LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState311 : ((('s, 'r) _menhir_cell1_STAR, 'r) _menhir_cell1_location, 'r) _menhir_state
    (** State 311.
        Stack shape : STAR location.
        Start symbol: <undetermined>. *)

  | MenhirState315 : (('s, 'r) _menhir_cell1_SRCU, 'r) _menhir_state
    (** State 315.
        Stack shape : SRCU.
        Start symbol: <undetermined>. *)

  | MenhirState318 : ((('s, 'r) _menhir_cell1_SRCU, 'r) _menhir_cell1_annot_list, 'r) _menhir_state
    (** State 318.
        Stack shape : SRCU annot_list.
        Start symbol: <undetermined>. *)

  | MenhirState322 : (((('s, 'r) _menhir_cell1_SRCU, 'r) _menhir_cell1_annot_list, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 322.
        Stack shape : SRCU annot_list expr.
        Start symbol: <undetermined>. *)

  | MenhirState327 : (('s, 'r) _menhir_cell1_SPINUNLOCK, 'r) _menhir_state
    (** State 327.
        Stack shape : SPINUNLOCK.
        Start symbol: <undetermined>. *)

  | MenhirState332 : (('s, 'r) _menhir_cell1_SPINLOCK, 'r) _menhir_state
    (** State 332.
        Stack shape : SPINLOCK.
        Start symbol: <undetermined>. *)

  | MenhirState337 : (('s, 'r) _menhir_cell1_NAME, 'r) _menhir_state
    (** State 337.
        Stack shape : NAME.
        Start symbol: <undetermined>. *)

  | MenhirState341 : (('s, 'r) _menhir_cell1_NAME, 'r) _menhir_state
    (** State 341.
        Stack shape : NAME.
        Start symbol: <undetermined>. *)

  | MenhirState344 : (('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 344.
        Stack shape : LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState346 : ((('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_VOID, 'r) _menhir_state
    (** State 346.
        Stack shape : LPAR VOID.
        Start symbol: <undetermined>. *)

  | MenhirState350 : (('s, 'r) _menhir_cell1_LOCK, 'r) _menhir_state
    (** State 350.
        Stack shape : LOCK.
        Start symbol: <undetermined>. *)

  | MenhirState354 : (('s, 'r) _menhir_cell1_LBRACE, 'r) _menhir_state
    (** State 354.
        Stack shape : LBRACE.
        Start symbol: <undetermined>. *)

  | MenhirState356 : (('s, 'r) _menhir_cell1_IF, 'r) _menhir_state
    (** State 356.
        Stack shape : IF.
        Start symbol: <undetermined>. *)

  | MenhirState358 : ((('s, 'r) _menhir_cell1_IF, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 358.
        Stack shape : IF expr.
        Start symbol: <undetermined>. *)

  | MenhirState368 : (('s, 'r) _menhir_cell1_typ _menhir_cell0_NAME, 'r) _menhir_state
    (** State 368.
        Stack shape : typ NAME.
        Start symbol: <undetermined>. *)

  | MenhirState376 : (((('s, 'r) _menhir_cell1_IF, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_block_ins, 'r) _menhir_state
    (** State 376.
        Stack shape : IF expr block_ins.
        Start symbol: <undetermined>. *)

  | MenhirState383 : (('s, 'r) _menhir_cell1_declaration, 'r) _menhir_state
    (** State 383.
        Stack shape : declaration.
        Start symbol: <undetermined>. *)

  | MenhirState385 : (('s, 'r) _menhir_cell1_block_ins, 'r) _menhir_state
    (** State 385.
        Stack shape : block_ins.
        Start symbol: <undetermined>. *)

  | MenhirState390 : (('s, 'r) _menhir_cell1_declaration, 'r) _menhir_state
    (** State 390.
        Stack shape : declaration.
        Start symbol: <undetermined>. *)

  | MenhirState392 : (('s, 'r) _menhir_cell1_block_ins, 'r) _menhir_state
    (** State 392.
        Stack shape : block_ins.
        Start symbol: <undetermined>. *)

  | MenhirState395 : (('s, 'r) _menhir_cell1_parameter_declaration, 'r) _menhir_state
    (** State 395.
        Stack shape : parameter_declaration.
        Start symbol: <undetermined>. *)

  | MenhirState397 : (('s, _menhir_box_deep_main) _menhir_cell1_trans_unit, _menhir_box_deep_main) _menhir_state
    (** State 397.
        Stack shape : trans_unit.
        Start symbol: deep_main. *)

  | MenhirState399 : (('s, 'r) _menhir_cell1_SCOPES, 'r) _menhir_state
    (** State 399.
        Stack shape : SCOPES.
        Start symbol: <undetermined>. *)

  | MenhirState401 : (('s, 'r) _menhir_cell1_LPAR _menhir_cell0_NAME, 'r) _menhir_state
    (** State 401.
        Stack shape : LPAR NAME.
        Start symbol: <undetermined>. *)

  | MenhirState406 : (('s, 'r) _menhir_cell1_scope_tree, 'r) _menhir_state
    (** State 406.
        Stack shape : scope_tree.
        Start symbol: <undetermined>. *)

  | MenhirState410 : (('s, 'r) _menhir_cell1_proc, 'r) _menhir_state
    (** State 410.
        Stack shape : proc.
        Start symbol: <undetermined>. *)

  | MenhirState415 : (('s, 'r) _menhir_cell1_REGIONS, 'r) _menhir_state
    (** State 415.
        Stack shape : REGIONS.
        Start symbol: <undetermined>. *)

  | MenhirState417 : (('s, 'r) _menhir_cell1_NAME, 'r) _menhir_state
    (** State 417.
        Stack shape : NAME.
        Start symbol: <undetermined>. *)

  | MenhirState418 : (('s, 'r) _menhir_cell1_NAME, 'r) _menhir_state
    (** State 418.
        Stack shape : NAME.
        Start symbol: <undetermined>. *)

  | MenhirState424 : (('s, 'r) _menhir_cell1_memory_map_atom, 'r) _menhir_state
    (** State 424.
        Stack shape : memory_map_atom.
        Start symbol: <undetermined>. *)

  | MenhirState428 : (('s, 'r) _menhir_cell1_LEVELS, 'r) _menhir_state
    (** State 428.
        Stack shape : LEVELS.
        Start symbol: <undetermined>. *)

  | MenhirState429 : (('s, 'r) _menhir_cell1_PROC, 'r) _menhir_state
    (** State 429.
        Stack shape : PROC.
        Start symbol: <undetermined>. *)

  | MenhirState431 : (('s, 'r) _menhir_cell1_LPAR _menhir_cell0_NAME, 'r) _menhir_state
    (** State 431.
        Stack shape : LPAR NAME.
        Start symbol: <undetermined>. *)

  | MenhirState434 : (('s, 'r) _menhir_cell1_level_tree, 'r) _menhir_state
    (** State 434.
        Stack shape : level_tree.
        Start symbol: <undetermined>. *)

  | MenhirState439 : (('s, 'r) _menhir_cell1_scopes_key, 'r) _menhir_state
    (** State 439.
        Stack shape : scopes_key.
        Start symbol: <undetermined>. *)

  | MenhirState440 : ((('s, 'r) _menhir_cell1_scopes_key, 'r) _menhir_cell1_memory_map_key, 'r) _menhir_state
    (** State 440.
        Stack shape : scopes_key memory_map_key.
        Start symbol: <undetermined>. *)

  | MenhirState442 : ((('s, 'r) _menhir_cell1_scopes_key, 'r) _menhir_cell1_levels_key, 'r) _menhir_state
    (** State 442.
        Stack shape : scopes_key levels_key.
        Start symbol: <undetermined>. *)

  | MenhirState447 : (('s, 'r) _menhir_cell1_memory_map_key, 'r) _menhir_state
    (** State 447.
        Stack shape : memory_map_key.
        Start symbol: <undetermined>. *)

  | MenhirState448 : ((('s, 'r) _menhir_cell1_memory_map_key, 'r) _menhir_cell1_scopes_key, 'r) _menhir_state
    (** State 448.
        Stack shape : memory_map_key scopes_key.
        Start symbol: <undetermined>. *)

  | MenhirState450 : ((('s, 'r) _menhir_cell1_memory_map_key, 'r) _menhir_cell1_levels_key, 'r) _menhir_state
    (** State 450.
        Stack shape : memory_map_key levels_key.
        Start symbol: <undetermined>. *)

  | MenhirState452 : (('s, 'r) _menhir_cell1_levels_key, 'r) _menhir_state
    (** State 452.
        Stack shape : levels_key.
        Start symbol: <undetermined>. *)

  | MenhirState453 : ((('s, 'r) _menhir_cell1_levels_key, 'r) _menhir_cell1_scopes_key, 'r) _menhir_state
    (** State 453.
        Stack shape : levels_key scopes_key.
        Start symbol: <undetermined>. *)

  | MenhirState455 : ((('s, 'r) _menhir_cell1_levels_key, 'r) _menhir_cell1_memory_map_key, 'r) _menhir_state
    (** State 455.
        Stack shape : levels_key memory_map_key.
        Start symbol: <undetermined>. *)

  | MenhirState460 : ('s, _menhir_box_macros) _menhir_state
    (** State 460.
        Stack shape : .
        Start symbol: macros. *)

  | MenhirState462 : (('s, _menhir_box_macros) _menhir_cell1_NAME, _menhir_box_macros) _menhir_state
    (** State 462.
        Stack shape : NAME.
        Start symbol: macros. *)

  | MenhirState464 : (('s, _menhir_box_macros) _menhir_cell1_NAME, _menhir_box_macros) _menhir_state
    (** State 464.
        Stack shape : NAME.
        Start symbol: macros. *)

  | MenhirState468 : ((('s, _menhir_box_macros) _menhir_cell1_NAME, _menhir_box_macros) _menhir_cell1_formals, _menhir_box_macros) _menhir_state
    (** State 468.
        Stack shape : NAME formals.
        Start symbol: macros. *)

  | MenhirState469 : (((('s, _menhir_box_macros) _menhir_cell1_NAME, _menhir_box_macros) _menhir_cell1_formals, _menhir_box_macros) _menhir_cell1_LBRACE, _menhir_box_macros) _menhir_state
    (** State 469.
        Stack shape : NAME formals LBRACE.
        Start symbol: macros. *)

  | MenhirState475 : (('s, _menhir_box_macros) _menhir_cell1_macro, _menhir_box_macros) _menhir_state
    (** State 475.
        Stack shape : macro.
        Start symbol: macros. *)

  | MenhirState479 : ('s, _menhir_box_pseudo_seq) _menhir_state
    (** State 479.
        Stack shape : .
        Start symbol: pseudo_seq. *)

  | MenhirState483 : ('s, _menhir_box_shallow_main) _menhir_state
    (** State 483.
        Stack shape : .
        Start symbol: shallow_main. *)

  | MenhirState484 : (('s, _menhir_box_shallow_main) _menhir_cell1_BODY, _menhir_box_shallow_main) _menhir_state
    (** State 484.
        Stack shape : BODY.
        Start symbol: shallow_main. *)

  | MenhirState487 : (('s, _menhir_box_shallow_main) _menhir_cell1_voidopt _menhir_cell0_PROC, _menhir_box_shallow_main) _menhir_state
    (** State 487.
        Stack shape : voidopt PROC.
        Start symbol: shallow_main. *)

  | MenhirState490 : ((('s, _menhir_box_shallow_main) _menhir_cell1_voidopt _menhir_cell0_PROC, _menhir_box_shallow_main) _menhir_cell1_parameter_list _menhir_cell0_BODY, _menhir_box_shallow_main) _menhir_state
    (** State 490.
        Stack shape : voidopt PROC parameter_list BODY.
        Start symbol: shallow_main. *)


and ('s, 'r) _menhir_cell1_annot = 
  | MenhirCell1_annot of 's * ('s, 'r) _menhir_state * (string)

and ('s, 'r) _menhir_cell1_annot_base = 
  | MenhirCell1_annot_base of 's * ('s, 'r) _menhir_state * (string)

and ('s, 'r) _menhir_cell1_annot_list = 
  | MenhirCell1_annot_list of 's * ('s, 'r) _menhir_state * (MemOrderOrAnnot.annot)

and ('s, 'r) _menhir_cell1_atomic_op = 
  | MenhirCell1_atomic_op of 's * ('s, 'r) _menhir_state * (CBase.op)

and ('s, 'r) _menhir_cell1_block_ins = 
  | MenhirCell1_block_ins of 's * ('s, 'r) _menhir_state * (CBase.pins)

and ('s, 'r) _menhir_cell1_declaration = 
  | MenhirCell1_declaration of 's * ('s, 'r) _menhir_state * (CBase.pins)

and ('s, 'r) _menhir_cell1_expr = 
  | MenhirCell1_expr of 's * ('s, 'r) _menhir_state * (CBase.expression)

and ('s, 'r) _menhir_cell1_expr0 = 
  | MenhirCell1_expr0 of 's * ('s, 'r) _menhir_state * (CBase.expression)

and ('s, 'r) _menhir_cell1_formals = 
  | MenhirCell1_formals of 's * ('s, 'r) _menhir_state * (string list)

and ('s, 'r) _menhir_cell1_level_tree = 
  | MenhirCell1_level_tree of 's * ('s, 'r) _menhir_state * (BellInfo.scopes)

and ('s, 'r) _menhir_cell1_levels_key = 
  | MenhirCell1_levels_key of 's * ('s, 'r) _menhir_state * (BellInfo.scopes)

and ('s, 'r) _menhir_cell1_location = 
  | MenhirCell1_location of 's * ('s, 'r) _menhir_state * (CBase.expression)

and ('s, 'r) _menhir_cell1_macro = 
  | MenhirCell1_macro of 's * ('s, 'r) _menhir_state * (CBase.macro)

and ('s, 'r) _menhir_cell1_memory_map_atom = 
  | MenhirCell1_memory_map_atom of 's * ('s, 'r) _menhir_state * (string * string list)

and ('s, 'r) _menhir_cell1_memory_map_key = 
  | MenhirCell1_memory_map_key of 's * ('s, 'r) _menhir_state * (BellInfo.mem_space_map)

and ('s, 'r) _menhir_cell1_parameter_declaration = 
  | MenhirCell1_parameter_declaration of 's * ('s, 'r) _menhir_state * (CAst.param)

and ('s, 'r) _menhir_cell1_parameter_list = 
  | MenhirCell1_parameter_list of 's * ('s, 'r) _menhir_state * (CAst.param list)

and ('s, 'r) _menhir_cell1_proc = 
  | MenhirCell1_proc of 's * ('s, 'r) _menhir_state * (int)

and ('s, 'r) _menhir_cell1_scope_tree = 
  | MenhirCell1_scope_tree of 's * ('s, 'r) _menhir_state * (BellInfo.scopes)

and ('s, 'r) _menhir_cell1_scopes_key = 
  | MenhirCell1_scopes_key of 's * ('s, 'r) _menhir_state * (BellInfo.scopes)

and ('s, 'r) _menhir_cell1_trans_unit = 
  | MenhirCell1_trans_unit of 's * ('s, 'r) _menhir_state * (CBase.pseudo list CAst.test list)

and ('s, 'r) _menhir_cell1_typ = 
  | MenhirCell1_typ of 's * ('s, 'r) _menhir_state * (CType.t)

and ('s, 'r) _menhir_cell1_voidopt = 
  | MenhirCell1_voidopt of 's * ('s, 'r) _menhir_state * (unit)

and ('s, 'r) _menhir_cell1_ATOMIC = 
  | MenhirCell1_ATOMIC of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_ATOMICADDUNLESS = 
  | MenhirCell1_ATOMICADDUNLESS of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_ATOMIC_FETCH_EXPLICIT = 
  | MenhirCell1_ATOMIC_FETCH_EXPLICIT of 's * ('s, 'r) _menhir_state * (
# 65 "lib/CParser.mly"
       (CBase.op)
# 1025 "lib/CParser.ml"
)

and ('s, 'r) _menhir_cell1_BODY = 
  | MenhirCell1_BODY of 's * ('s, 'r) _menhir_state * (
# 46 "lib/CParser.mly"
       (string)
# 1032 "lib/CParser.ml"
)

and 's _menhir_cell0_BODY = 
  | MenhirCell0_BODY of 's * (
# 46 "lib/CParser.mly"
       (string)
# 1039 "lib/CParser.ml"
)

and ('s, 'r) _menhir_cell1_CMPXCHG = 
  | MenhirCell1_CMPXCHG of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_CONST = 
  | MenhirCell1_CONST of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_EXC_EXPLICIT = 
  | MenhirCell1_EXC_EXPLICIT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_IF = 
  | MenhirCell1_IF of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LBRACE = 
  | MenhirCell1_LBRACE of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LD_EXPLICIT = 
  | MenhirCell1_LD_EXPLICIT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LEVELS = 
  | MenhirCell1_LEVELS of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LOAD = 
  | MenhirCell1_LOAD of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LOCK = 
  | MenhirCell1_LOCK of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LPAR = 
  | MenhirCell1_LPAR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_NAME = 
  | MenhirCell1_NAME of 's * ('s, 'r) _menhir_state * (
# 27 "lib/CParser.mly"
       (string)
# 1076 "lib/CParser.ml"
)

and 's _menhir_cell0_NAME = 
  | MenhirCell0_NAME of 's * (
# 27 "lib/CParser.mly"
       (string)
# 1083 "lib/CParser.ml"
)

and ('s, 'r) _menhir_cell1_PROC = 
  | MenhirCell1_PROC of 's * ('s, 'r) _menhir_state * (
# 33 "lib/CParser.mly"
       (int)
# 1090 "lib/CParser.ml"
)

and 's _menhir_cell0_PROC = 
  | MenhirCell0_PROC of 's * (
# 33 "lib/CParser.mly"
       (int)
# 1097 "lib/CParser.ml"
)

and ('s, 'r) _menhir_cell1_REGIONS = 
  | MenhirCell1_REGIONS of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SCAS = 
  | MenhirCell1_SCAS of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SCAS_EXPLICIT = 
  | MenhirCell1_SCAS_EXPLICIT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SCOPES = 
  | MenhirCell1_SCOPES of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SPINISLOCKED = 
  | MenhirCell1_SPINISLOCKED of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SPINLOCK = 
  | MenhirCell1_SPINLOCK of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SPINTRYLOCK = 
  | MenhirCell1_SPINTRYLOCK of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SPINUNLOCK = 
  | MenhirCell1_SPINUNLOCK of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SRCU = 
  | MenhirCell1_SRCU of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_STAR = 
  | MenhirCell1_STAR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_STORE = 
  | MenhirCell1_STORE of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_ST_EXPLICIT = 
  | MenhirCell1_ST_EXPLICIT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_UNDERATOMICADDUNLESS = 
  | MenhirCell1_UNDERATOMICADDUNLESS of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_UNDERATOMICFETCHOP = 
  | MenhirCell1_UNDERATOMICFETCHOP of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_UNDERATOMICOP = 
  | MenhirCell1_UNDERATOMICOP of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_UNDERATOMICOPRETURN = 
  | MenhirCell1_UNDERATOMICOPRETURN of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_UNDERFENCE = 
  | MenhirCell1_UNDERFENCE of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_UNLOCK = 
  | MenhirCell1_UNLOCK of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_VOID = 
  | MenhirCell1_VOID of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_VOLATILE = 
  | MenhirCell1_VOLATILE of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_WCAS = 
  | MenhirCell1_WCAS of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_WCAS_EXPLICIT = 
  | MenhirCell1_WCAS_EXPLICIT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_WHILE = 
  | MenhirCell1_WHILE of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_XCHG = 
  | MenhirCell1_XCHG of 's * ('s, 'r) _menhir_state

and _menhir_box_shallow_main = 
  | MenhirBox_shallow_main of (string CAst.t list * MiscParser.extra_data) [@@unboxed]

and _menhir_box_pseudo_seq = 
  | MenhirBox_pseudo_seq of (CBase.pseudo list) [@@unboxed]

and _menhir_box_macros = 
  | MenhirBox_macros of (CBase.macro list) [@@unboxed]

and _menhir_box_deep_main = 
  | MenhirBox_deep_main of (CBase.pseudo list CAst.test list * MiscParser.extra_data) [@@unboxed]

let _menhir_action_004 =
  fun _1 ->
    (
# 165 "lib/CParser.mly"
              ( _1 )
# 1189 "lib/CParser.ml"
     : (string))

let _menhir_action_005 =
  fun _1 _3 ->
    (
# 166 "lib/CParser.mly"
                       ( _1 ^ "-" ^ _3 )
# 1197 "lib/CParser.ml"
     : (string))

let _menhir_action_006 =
  fun () ->
    (
# 169 "lib/CParser.mly"
             ( "lock" )
# 1205 "lib/CParser.ml"
     : (string))

let _menhir_action_007 =
  fun () ->
    (
# 170 "lib/CParser.mly"
             ( "unlock" )
# 1213 "lib/CParser.ml"
     : (string))

let _menhir_action_008 =
  fun () ->
    (
# 171 "lib/CParser.mly"
              ( "atomic" )
# 1221 "lib/CParser.ml"
     : (string))

let _menhir_action_009 =
  fun _1 ->
    (
# 172 "lib/CParser.mly"
       ( _1 )
# 1229 "lib/CParser.ml"
     : (string))

let _menhir_action_010 =
  fun _1 _3 ->
    (
# 178 "lib/CParser.mly"
  (_1::_3)
# 1237 "lib/CParser.ml"
     : (MemOrderOrAnnot.annot))

let _menhir_action_011 =
  fun _1 ->
    (
# 180 "lib/CParser.mly"
  ([_1])
# 1245 "lib/CParser.ml"
     : (MemOrderOrAnnot.annot))

let _menhir_action_012 =
  fun () ->
    (
# 245 "lib/CParser.mly"
  ( [] )
# 1253 "lib/CParser.ml"
     : (CBase.expression list))

let _menhir_action_013 =
  fun _1 ->
    (
# 246 "lib/CParser.mly"
          ( _1 )
# 1261 "lib/CParser.ml"
     : (CBase.expression list))

let _menhir_action_014 =
  fun _1 ->
    (
# 249 "lib/CParser.mly"
       ( [_1] )
# 1269 "lib/CParser.ml"
     : (CBase.expression list))

let _menhir_action_015 =
  fun _1 _3 ->
    (
# 250 "lib/CParser.mly"
                     ( _1 :: _3 )
# 1277 "lib/CParser.ml"
     : (CBase.expression list))

let _menhir_action_016 =
  fun () ->
    (
# 161 "lib/CParser.mly"
      ( Op.Add )
# 1285 "lib/CParser.ml"
     : (CBase.op))

let _menhir_action_017 =
  fun () ->
    (
# 162 "lib/CParser.mly"
      ( Op.Sub )
# 1293 "lib/CParser.ml"
     : (CBase.op))

let _menhir_action_018 =
  fun _1 ->
    (
# 132 "lib/CParser.mly"
        ( _1 )
# 1301 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_019 =
  fun _2 ->
    (
# 133 "lib/CParser.mly"
                 ( _2 )
# 1309 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_020 =
  fun _1 ->
    (
# 120 "lib/CParser.mly"
              ( Atomic (Base _1) )
# 1317 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_021 =
  fun _3 ->
    (
# 121 "lib/CParser.mly"
                              ( Atomic (Base _3) )
# 1325 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_022 =
  fun _1 ->
    (
# 122 "lib/CParser.mly"
            ( (Base _1) )
# 1333 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_023 =
  fun _2 ->
    (
# 123 "lib/CParser.mly"
                     ( Base ("struct " ^ _2) )
# 1341 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_024 =
  fun _1 ->
    (
# 124 "lib/CParser.mly"
                ( Base (_1 ^ "mutex") )
# 1349 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_025 =
  fun _1 ->
    (
# 125 "lib/CParser.mly"
               ( Base (_1 ^ "char") )
# 1357 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_026 =
  fun _1 ->
    (
# 126 "lib/CParser.mly"
              ( Base (_1 ^ "int") )
# 1365 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_027 =
  fun _1 ->
    (
# 127 "lib/CParser.mly"
               ( Base (_1 ^ "long") )
# 1373 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_028 =
  fun _1 ->
    (
# 306 "lib/CParser.mly"
              ( _1 )
# 1381 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_029 =
  fun _2 ->
    (
# 307 "lib/CParser.mly"
                        ( Seq(_2,true) )
# 1389 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_030 =
  fun _2 ->
    (
# 342 "lib/CParser.mly"
                        ( Seq (_2,true) )
# 1397 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_031 =
  fun _1 _2 ->
    (
# 151 "lib/CParser.mly"
                ( DeclReg (_1,_2) )
# 1405 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_032 =
  fun _1 _2 ->
    (
# 331 "lib/CParser.mly"
                                       ( _1, [MiscParser.BellExtra _2] )
# 1413 "lib/CParser.ml"
     : (CBase.pseudo list CAst.test list * MiscParser.extra_data))

let _menhir_action_033 =
  fun _1 ->
    (
# 310 "lib/CParser.mly"
            ( [Instruction _1] )
# 1421 "lib/CParser.ml"
     : (CBase.pseudo list))

let _menhir_action_034 =
  fun _1 _2 ->
    (
# 311 "lib/CParser.mly"
                          ( (Instruction _1)::_2 )
# 1429 "lib/CParser.ml"
     : (CBase.pseudo list))

let _menhir_action_035 =
  fun () ->
    (
# 312 "lib/CParser.mly"
              ( [] )
# 1437 "lib/CParser.ml"
     : (CBase.pseudo list))

let _menhir_action_036 =
  fun _2 ->
    (
# 313 "lib/CParser.mly"
                            ( _2 )
# 1445 "lib/CParser.ml"
     : (CBase.pseudo list))

let _menhir_action_037 =
  fun _1 ->
    (
# 183 "lib/CParser.mly"
        ( _1 )
# 1453 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_038 =
  fun _1 ->
    (
# 184 "lib/CParser.mly"
        ( _1 )
# 1461 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_039 =
  fun _1 ->
    (
# 187 "lib/CParser.mly"
           ( CBase.Const(Constant.Concrete _1) )
# 1469 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_040 =
  fun _1 ->
    (
# 188 "lib/CParser.mly"
           ( CBase.Const(mk_sym _1) )
# 1477 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_041 =
  fun _1 ->
    (
# 189 "lib/CParser.mly"
       ( CBase.LoadReg _1 )
# 1485 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_042 =
  fun _2 ->
    (
# 190 "lib/CParser.mly"
            ( CBase.LoadMem (CBase.LoadReg _2,AN []) )
# 1493 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_043 =
  fun _2 ->
    (
# 191 "lib/CParser.mly"
                 ( _2 )
# 1501 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_044 =
  fun e ->
    (
# 194 "lib/CParser.mly"
                                  ( e )
# 1509 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_045 =
  fun _5 ->
    (
# 195 "lib/CParser.mly"
                          ( LoadMem (LoadReg _5,AN []) )
# 1517 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_046 =
  fun _3 ->
    (
# 196 "lib/CParser.mly"
                      ( LoadMem (_3,AN []) )
# 1525 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_047 =
  fun _3 _6 ->
    (
# 197 "lib/CParser.mly"
                                               ( LoadMem(_6,AN _3) )
# 1533 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_048 =
  fun _3 _6 ->
    (
# 198 "lib/CParser.mly"
                                                           ( ExpSRCU(_6,_3) )
# 1541 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_049 =
  fun _3 _5 ->
    (
# 199 "lib/CParser.mly"
                                            ( LoadMem(_3,MO _5) )
# 1549 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_050 =
  fun _1 _3 ->
    (
# 200 "lib/CParser.mly"
                 ( Op(Op.Mul,_1,_3) )
# 1557 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_051 =
  fun _1 _3 ->
    (
# 201 "lib/CParser.mly"
                ( Op(Op.Add,_1,_3) )
# 1565 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_052 =
  fun _1 _3 ->
    (
# 202 "lib/CParser.mly"
                ( Op(Op.Sub,_1,_3) )
# 1573 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_053 =
  fun _1 _3 ->
    (
# 203 "lib/CParser.mly"
                ( Op(Op.Div,_1,_3) )
# 1581 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_054 =
  fun _1 _3 ->
    (
# 204 "lib/CParser.mly"
                 ( Op(Op.And,_1,_3) )
# 1589 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_055 =
  fun _1 _3 ->
    (
# 205 "lib/CParser.mly"
                 ( Op(Op.Or,_1,_3) )
# 1597 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_056 =
  fun _1 _3 ->
    (
# 206 "lib/CParser.mly"
                ( Op(Op.Xor,_1,_3) )
# 1605 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_057 =
  fun _1 _3 ->
    (
# 207 "lib/CParser.mly"
                  ( Op(Op.Eq,_1,_3) )
# 1613 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_058 =
  fun _1 _3 ->
    (
# 208 "lib/CParser.mly"
                   ( Op(Op.Ne,_1,_3) )
# 1621 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_059 =
  fun _1 _3 ->
    (
# 209 "lib/CParser.mly"
               ( Op(Op.Lt,_1,_3) )
# 1629 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_060 =
  fun _1 _3 ->
    (
# 210 "lib/CParser.mly"
               ( Op(Op.Gt,_1,_3) )
# 1637 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_061 =
  fun _1 _3 ->
    (
# 211 "lib/CParser.mly"
               ( Op(Op.Le,_1,_3) )
# 1645 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_062 =
  fun _1 _3 ->
    (
# 212 "lib/CParser.mly"
               ( Op(Op.Ge,_1,_3) )
# 1653 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_063 =
  fun _3 _5 _7 ->
    (
# 214 "lib/CParser.mly"
  ( Exchange(_3, _5, MO _7) )
# 1661 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_064 =
  fun _3 _6 _8 ->
    (
# 216 "lib/CParser.mly"
  ( Exchange(_6,_8,AN _3) )
# 1669 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_065 =
  fun _10 _3 _6 _8 ->
    (
# 218 "lib/CParser.mly"
  ( CmpExchange(_6,_8,_10,_3) )
# 1677 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_066 =
  fun _1 _3 _5 _7 ->
    (
# 220 "lib/CParser.mly"
  ( Fetch(_3, _1, _5, _7) )
# 1685 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_067 =
  fun _1 _3 ->
    (
# 222 "lib/CParser.mly"
  ( ECall (_1,_3) )
# 1693 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_068 =
  fun _3 _5 _7 ->
    (
# 224 "lib/CParser.mly"
  ( ECas (_3,_5,_7,SC,SC,false) )
# 1701 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_069 =
  fun _11 _3 _5 _7 _9 ->
    (
# 226 "lib/CParser.mly"
  ( ECas (_3,_5,_7,_9,_11,false) )
# 1709 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_070 =
  fun _3 _5 _7 ->
    (
# 228 "lib/CParser.mly"
  ( ECas (_3,_5,_7,SC,SC,true) )
# 1717 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_071 =
  fun _11 _3 _5 _7 _9 ->
    (
# 230 "lib/CParser.mly"
  ( ECas (_3,_5,_7,_9,_11,true) )
# 1725 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_072 =
  fun _3 ->
    (
# 232 "lib/CParser.mly"
  ( TryLock (_3,MutexLinux) )
# 1733 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_073 =
  fun _3 ->
    (
# 234 "lib/CParser.mly"
  ( IsLocked (_3,MutexLinux) )
# 1741 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_074 =
  fun _10 _3 _6 _8 ->
    (
# 236 "lib/CParser.mly"
  ( AtomicOpReturn(_6,_8,_10,OpReturn,_3) )
# 1749 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_075 =
  fun _10 _3 _6 _8 ->
    (
# 238 "lib/CParser.mly"
  ( AtomicOpReturn(_6,_8,_10,FetchOp,_3) )
# 1757 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_076 =
  fun _3 _5 _7 ->
    (
# 240 "lib/CParser.mly"
  ( AtomicAddUnless(_3,_5,_7,false) )
# 1765 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_077 =
  fun _3 _5 _7 ->
    (
# 242 "lib/CParser.mly"
  ( AtomicAddUnless(_3,_5,_7,true) )
# 1773 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_078 =
  fun e ->
    (
# 158 "lib/CParser.mly"
         ( StoreReg(None,None,e) )
# 1781 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_079 =
  fun () ->
    (
# 338 "lib/CParser.mly"
  ( [] )
# 1789 "lib/CParser.ml"
     : (string list))

let _menhir_action_080 =
  fun _1 ->
    (
# 339 "lib/CParser.mly"
             ( _1 )
# 1797 "lib/CParser.ml"
     : (string list))

let _menhir_action_081 =
  fun _1 ->
    (
# 334 "lib/CParser.mly"
       ( [ _1 ] )
# 1805 "lib/CParser.ml"
     : (string list))

let _menhir_action_082 =
  fun _1 _3 ->
    (
# 335 "lib/CParser.mly"
                        ( _1 :: _3 )
# 1813 "lib/CParser.ml"
     : (string list))

let _menhir_action_083 =
  fun _2 _4 _7 ->
    (
# 320 "lib/CParser.mly"
  ( { CAst.proc = _2;
      CAst.params = _4;
      CAst.body = _7 } )
# 1823 "lib/CParser.ml"
     : (CBase.pseudo list CAst.test))

let _menhir_action_084 =
  fun _1 _2 _4 ->
    (
# 154 "lib/CParser.mly"
                   ( StoreReg (Some _1,Some _2,_4) ; )
# 1831 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_085 =
  fun _1 ->
    (
# 155 "lib/CParser.mly"
            ( _1 )
# 1839 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_086 =
  fun _1 ->
    (
# 300 "lib/CParser.mly"
            ( [_1] )
# 1847 "lib/CParser.ml"
     : (CBase.pins list))

let _menhir_action_087 =
  fun _1 _2 ->
    (
# 301 "lib/CParser.mly"
                    ( _1::_2 )
# 1855 "lib/CParser.ml"
     : (CBase.pins list))

let _menhir_action_088 =
  fun _1 ->
    (
# 302 "lib/CParser.mly"
              ( [_1] )
# 1863 "lib/CParser.ml"
     : (CBase.pins list))

let _menhir_action_089 =
  fun _1 _2 ->
    (
# 303 "lib/CParser.mly"
                      ( _1::_2 )
# 1871 "lib/CParser.ml"
     : (CBase.pins list))

let _menhir_action_090 =
  fun _3 _5 ->
    (
# 259 "lib/CParser.mly"
  ( If(_3,_5,None) )
# 1879 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_091 =
  fun _3 _5 _7 ->
    (
# 261 "lib/CParser.mly"
  ( If(_3,_5,Some _7) )
# 1887 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_092 =
  fun _2 _3 ->
    (
# 263 "lib/CParser.mly"
  ( While (_2,_3,0) )
# 1895 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_093 =
  fun _1 ->
    (
# 265 "lib/CParser.mly"
  ( _1 )
# 1903 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_094 =
  fun _1 _3 ->
    (
# 267 "lib/CParser.mly"
  ( StoreReg(None,Some _1,_3) )
# 1911 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_095 =
  fun _4 ->
    (
# 269 "lib/CParser.mly"
  ( CastExpr _4 )
# 1919 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_096 =
  fun _2 _4 ->
    (
# 271 "lib/CParser.mly"
  ( StoreMem(_2,_4,AN []) )
# 1927 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_097 =
  fun _3 _6 _8 ->
    (
# 273 "lib/CParser.mly"
  ( StoreMem(_6,_8,AN _3) )
# 1935 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_098 =
  fun _3 _6 ->
    (
# 275 "lib/CParser.mly"
  ( InstrSRCU(_6,_3,None) )
# 1943 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_099 =
  fun _3 _6 _8 ->
    (
# 277 "lib/CParser.mly"
  ( InstrSRCU(_6,_3,Some _8) )
# 1951 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_100 =
  fun _3 _5 _7 ->
    (
# 279 "lib/CParser.mly"
  ( StoreMem(_3, _5, MO _7) )
# 1959 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_101 =
  fun _3 ->
    (
# 281 "lib/CParser.mly"
  ( Lock (_3,MutexC11) )
# 1967 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_102 =
  fun _3 ->
    (
# 283 "lib/CParser.mly"
  ( Unlock (_3,MutexC11) )
# 1975 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_103 =
  fun _3 ->
    (
# 285 "lib/CParser.mly"
  ( Lock (_3,MutexLinux) )
# 1983 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_104 =
  fun _3 ->
    (
# 287 "lib/CParser.mly"
  ( Unlock (_3,MutexLinux) )
# 1991 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_105 =
  fun _3 ->
    (
# 289 "lib/CParser.mly"
  ( Fence(AN _3) )
# 1999 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_106 =
  fun _3 _5 _7 ->
    (
# 291 "lib/CParser.mly"
  ( AtomicOp(_3,_5,_7) )
# 2007 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_107 =
  fun _3 ->
    (
# 293 "lib/CParser.mly"
  ( Fence(MO _3) )
# 2015 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_108 =
  fun _1 ->
    (
# 295 "lib/CParser.mly"
  ( Symb _1 )
# 2023 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_109 =
  fun _1 _3 ->
    (
# 297 "lib/CParser.mly"
  ( PCall (_1,_3) )
# 2031 "lib/CParser.ml"
     : (CBase.pins))

let _menhir_action_110 =
  fun _2 _3 ->
    (
# 62 "lib/scopeRules.mly"
  (
   let ps,ts = _3 in
   BellInfo.Tree (_2,ps,ts)
   )
# 2042 "lib/CParser.ml"
     : (BellInfo.scopes))

let _menhir_action_111 =
  fun _1 ->
    (
# 51 "lib/scopeRules.mly"
       ( [_1],[] )
# 2050 "lib/CParser.ml"
     : (int list * BellInfo.scopes list))

let _menhir_action_112 =
  fun _1 ->
    (
# 52 "lib/scopeRules.mly"
             (let ps =  [] in ps,[_1])
# 2058 "lib/CParser.ml"
     : (int list * BellInfo.scopes list))

let _menhir_action_113 =
  fun _1 _2 ->
    (
# 54 "lib/scopeRules.mly"
    ( let ps,ts = _2 in
      _1::ps,ts )
# 2067 "lib/CParser.ml"
     : (int list * BellInfo.scopes list))

let _menhir_action_114 =
  fun _1 _2 ->
    (
# 57 "lib/scopeRules.mly"
    (let ps,ts = _2 in
     ps,_1::ts )
# 2076 "lib/CParser.ml"
     : (int list * BellInfo.scopes list))

let _menhir_action_115 =
  fun _3 ->
    (
# 53 "lib/BellExtraRules.mly"
                              ( _3 )
# 2084 "lib/CParser.ml"
     : (BellInfo.scopes))

let _menhir_action_116 =
  fun () ->
    (
# 216 "<standard.mly>"
    ( [] )
# 2092 "lib/CParser.ml"
     : (CBase.macro list))

let _menhir_action_117 =
  fun x xs ->
    (
# 219 "<standard.mly>"
    ( x :: xs )
# 2100 "lib/CParser.ml"
     : (CBase.macro list))

let _menhir_action_118 =
  fun _1 ->
    (
# 253 "lib/CParser.mly"
       ( LoadReg(_1) )
# 2108 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_119 =
  fun _2 ->
    (
# 254 "lib/CParser.mly"
                ( LoadMem(_2,AN []) )
# 2116 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_120 =
  fun _2 ->
    (
# 255 "lib/CParser.mly"
                 ( _2 )
# 2124 "lib/CParser.ml"
     : (CBase.expression))

let _menhir_action_121 =
  fun () ->
    (
# 145 "<standard.mly>"
    ( [] )
# 2132 "lib/CParser.ml"
     : (BellInfo.mem_space_map))

let _menhir_action_122 =
  fun x ->
    (
# 148 "<standard.mly>"
    ( x )
# 2140 "lib/CParser.ml"
     : (BellInfo.mem_space_map))

let _menhir_action_123 =
  fun _1 _3 _5 ->
    (
# 345 "lib/CParser.mly"
                              ( EDef (_1,_3,_5) )
# 2148 "lib/CParser.ml"
     : (CBase.macro))

let _menhir_action_124 =
  fun _1 _3 _5 ->
    (
# 346 "lib/CParser.mly"
                              ( PDef (_1,_3,_5) )
# 2156 "lib/CParser.ml"
     : (CBase.macro))

let _menhir_action_125 =
  fun ms ->
    (
# 349 "lib/CParser.mly"
                     ( ms )
# 2164 "lib/CParser.ml"
     : (CBase.macro list))

let _menhir_action_126 =
  fun _1 _3 ->
    (
# 75 "lib/scopeRules.mly"
                                  ( (_1,_3) )
# 2172 "lib/CParser.ml"
     : (string * string list))

let _menhir_action_127 =
  fun _3 ->
    (
# 56 "lib/BellExtraRules.mly"
                               ( _3 )
# 2180 "lib/CParser.ml"
     : (BellInfo.mem_space_map))

let _menhir_action_128 =
  fun x ->
    (
# 228 "<standard.mly>"
    ( [ x ] )
# 2188 "lib/CParser.ml"
     : (string list))

let _menhir_action_129 =
  fun x xs ->
    (
# 231 "<standard.mly>"
    ( x :: xs )
# 2196 "lib/CParser.ml"
     : (string list))

let _menhir_action_130 =
  fun _1 _2 ->
    (
# 96 "lib/CParser.mly"
               ( {CAst.param_ty = _1; param_name = _2} )
# 2204 "lib/CParser.ml"
     : (CAst.param))

let _menhir_action_131 =
  fun () ->
    (
# 91 "lib/CParser.mly"
  ( [] )
# 2212 "lib/CParser.ml"
     : (CAst.param list))

let _menhir_action_132 =
  fun _1 ->
    (
# 92 "lib/CParser.mly"
                        ( [ _1 ] )
# 2220 "lib/CParser.ml"
     : (CAst.param list))

let _menhir_action_133 =
  fun _1 _3 ->
    (
# 93 "lib/CParser.mly"
                                             ( _1 :: _3 )
# 2228 "lib/CParser.ml"
     : (CAst.param list))

let _menhir_action_134 =
  fun levels regions scopes ->
    (
# 30 "lib/BellExtraRules.mly"
    ( { levels=Some levels; scopes=Some scopes; regions=Some regions; } )
# 2236 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_135 =
  fun levels regions scopes ->
    (
# 30 "lib/BellExtraRules.mly"
    ( { levels=Some levels; scopes=Some scopes; regions=Some regions; } )
# 2244 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_136 =
  fun levels regions scopes ->
    (
# 30 "lib/BellExtraRules.mly"
    ( { levels=Some levels; scopes=Some scopes; regions=Some regions; } )
# 2252 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_137 =
  fun levels regions scopes ->
    (
# 30 "lib/BellExtraRules.mly"
    ( { levels=Some levels; scopes=Some scopes; regions=Some regions; } )
# 2260 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_138 =
  fun levels regions scopes ->
    (
# 30 "lib/BellExtraRules.mly"
    ( { levels=Some levels; scopes=Some scopes; regions=Some regions; } )
# 2268 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_139 =
  fun levels regions scopes ->
    (
# 30 "lib/BellExtraRules.mly"
    ( { levels=Some levels; scopes=Some scopes; regions=Some regions; } )
# 2276 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_140 =
  fun levels scopes ->
    (
# 33 "lib/BellExtraRules.mly"
    ( { nones with  levels=Some levels; scopes=Some scopes; } )
# 2284 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_141 =
  fun levels scopes ->
    (
# 33 "lib/BellExtraRules.mly"
    ( { nones with  levels=Some levels; scopes=Some scopes; } )
# 2292 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_142 =
  fun regions scopes ->
    (
# 36 "lib/BellExtraRules.mly"
    ( { nones with scopes=Some scopes; regions=Some regions; } )
# 2300 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_143 =
  fun regions scopes ->
    (
# 36 "lib/BellExtraRules.mly"
    ( { nones with scopes=Some scopes; regions=Some regions; } )
# 2308 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_144 =
  fun levels regions ->
    (
# 39 "lib/BellExtraRules.mly"
    ( { nones with levels=Some levels; regions=Some regions; } )
# 2316 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_145 =
  fun levels regions ->
    (
# 39 "lib/BellExtraRules.mly"
    ( { nones with levels=Some levels; regions=Some regions; } )
# 2324 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_146 =
  fun scopes ->
    (
# 41 "lib/BellExtraRules.mly"
    ( { nones with scopes=Some scopes; } )
# 2332 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_147 =
  fun levels ->
    (
# 43 "lib/BellExtraRules.mly"
    ( { nones with levels=Some levels; } )
# 2340 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_148 =
  fun regions ->
    (
# 45 "lib/BellExtraRules.mly"
    ( { nones with regions=Some regions; } )
# 2348 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_149 =
  fun () ->
    (
# 47 "lib/BellExtraRules.mly"
    (  nones )
# 2356 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_150 =
  fun _1 ->
    (
# 22 "lib/scopeRules.mly"
        ( _1 )
# 2364 "lib/CParser.ml"
     : (int))

let _menhir_action_151 =
  fun _1 ->
    (
# 23 "lib/scopeRules.mly"
        ( _1 )
# 2372 "lib/CParser.ml"
     : (int))

let _menhir_action_152 =
  fun _1 _2 ->
    (
# 26 "lib/scopeRules.mly"
                    (_1::_2)
# 2380 "lib/CParser.ml"
     : (int list))

let _menhir_action_153 =
  fun () ->
    (
# 27 "lib/scopeRules.mly"
  ([])
# 2388 "lib/CParser.ml"
     : (int list))

let _menhir_action_154 =
  fun p ->
    (
# 316 "lib/CParser.mly"
                      ( p )
# 2396 "lib/CParser.ml"
     : (CBase.pseudo list))

let _menhir_action_155 =
  fun _2 _3 ->
    (
# 35 "lib/scopeRules.mly"
   (
   BellInfo.Tree(_2,[],_3)
   )
# 2406 "lib/CParser.ml"
     : (BellInfo.scopes))

let _menhir_action_156 =
  fun _2 _3 ->
    (
# 39 "lib/scopeRules.mly"
   (
   BellInfo.Tree(_2,_3,[])
   )
# 2416 "lib/CParser.ml"
     : (BellInfo.scopes))

let _menhir_action_157 =
  fun _1 ->
    (
# 30 "lib/scopeRules.mly"
             ([_1])
# 2424 "lib/CParser.ml"
     : (BellInfo.scopes list))

let _menhir_action_158 =
  fun _1 _2 ->
    (
# 31 "lib/scopeRules.mly"
                             (_1::_2)
# 2432 "lib/CParser.ml"
     : (BellInfo.scopes list))

let _menhir_action_159 =
  fun x ->
    (
# 61 "lib/BellExtraRules.mly"
                                                    ( x )
# 2440 "lib/CParser.ml"
     : (BellInfo.test))

let _menhir_action_160 =
  fun _3 ->
    (
# 50 "lib/BellExtraRules.mly"
                              ( _3 )
# 2448 "lib/CParser.ml"
     : (BellInfo.scopes))

let _menhir_action_161 =
  fun x ->
    (
# 250 "<standard.mly>"
    ( [ x ] )
# 2456 "lib/CParser.ml"
     : (BellInfo.mem_space_map))

let _menhir_action_162 =
  fun x xs ->
    (
# 253 "<standard.mly>"
    ( x :: xs )
# 2464 "lib/CParser.ml"
     : (BellInfo.mem_space_map))

let _menhir_action_163 =
  fun _1 ->
    (
# 139 "lib/CParser.mly"
                            ( [], [MiscParser.BellExtra _1] )
# 2472 "lib/CParser.ml"
     : (string CAst.t list * MiscParser.extra_data))

let _menhir_action_164 =
  fun _1 _2 ->
    (
# 140 "lib/CParser.mly"
                    ( CAst.Global _1 :: (fst _2), (snd _2) )
# 2480 "lib/CParser.ml"
     : (string CAst.t list * MiscParser.extra_data))

let _menhir_action_165 =
  fun _2 _4 _6 _7 ->
    (
# 142 "lib/CParser.mly"
    ( CAst.Test {CAst.proc = _2; params = _4; body = _6} :: (fst _7),
      (snd _7) )
# 2489 "lib/CParser.ml"
     : (string CAst.t list * MiscParser.extra_data))

let _menhir_action_166 =
  fun _1 ->
    (
# 69 "lib/scopeRules.mly"
    ( let ps,ts = _1 in
      match ps,ts with
      | [],[t] -> t
      | _ -> BellInfo.Tree ("",ps,ts) )
# 2500 "lib/CParser.ml"
     : (BellInfo.scopes))

let _menhir_action_167 =
  fun xs ->
    let atoms = 
# 241 "<standard.mly>"
    ( xs )
# 2508 "lib/CParser.ml"
     in
    (
# 78 "lib/scopeRules.mly"
                                                 ( atoms )
# 2513 "lib/CParser.ml"
     : (BellInfo.mem_space_map))

let _menhir_action_168 =
  fun _1 ->
    (
# 45 "lib/scopeRules.mly"
    ( let ts = _1 in
      match ts with
      | [t] -> t
      | _ -> BellInfo.Tree ("",[],ts) )
# 2524 "lib/CParser.ml"
     : (BellInfo.scopes))

let _menhir_action_169 =
  fun _1 ->
    (
# 326 "lib/CParser.mly"
  ( [_1] )
# 2532 "lib/CParser.ml"
     : (CBase.pseudo list CAst.test list))

let _menhir_action_170 =
  fun _1 _2 ->
    (
# 328 "lib/CParser.mly"
  ( _1 @ [_2] )
# 2540 "lib/CParser.ml"
     : (CBase.pseudo list CAst.test list))

let _menhir_action_171 =
  fun () ->
    (
# 136 "lib/CParser.mly"
  ( "" )
# 2548 "lib/CParser.ml"
     : (string))

let _menhir_action_172 =
  fun _1 ->
    (
# 111 "lib/CParser.mly"
          ( _1 )
# 2556 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_173 =
  fun _1 ->
    (
# 112 "lib/CParser.mly"
                   ( Volatile _1 )
# 2564 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_174 =
  fun _1 ->
    (
# 113 "lib/CParser.mly"
                ( CType.Const _1 )
# 2572 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_175 =
  fun _2 ->
    (
# 114 "lib/CParser.mly"
              ( Atomic _2 )
# 2580 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_176 =
  fun _2 ->
    (
# 115 "lib/CParser.mly"
                ( Volatile _2 )
# 2588 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_177 =
  fun _2 ->
    (
# 116 "lib/CParser.mly"
             ( Const _2 )
# 2596 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_178 =
  fun _1 ->
    (
# 117 "lib/CParser.mly"
        ( _1 )
# 2604 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_179 =
  fun t ->
    (
# 107 "lib/CParser.mly"
       ( t )
# 2612 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_180 =
  fun t ->
    (
# 108 "lib/CParser.mly"
                  ( t )
# 2620 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_181 =
  fun _1 ->
    (
# 99 "lib/CParser.mly"
           ( Pointer _1 )
# 2628 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_182 =
  fun _1 ->
    (
# 100 "lib/CParser.mly"
            ( Pointer _1 )
# 2636 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_183 =
  fun () ->
    (
# 103 "lib/CParser.mly"
       ( Base "void" )
# 2644 "lib/CParser.ml"
     : (CType.t))

let _menhir_action_184 =
  fun () ->
    (
# 146 "lib/CParser.mly"
       ( () )
# 2652 "lib/CParser.ml"
     : (unit))

let _menhir_action_185 =
  fun () ->
    (
# 147 "lib/CParser.mly"
            ( () )
# 2660 "lib/CParser.ml"
     : (unit))

let _menhir_action_186 =
  fun () ->
    (
# 148 "lib/CParser.mly"
  ( () )
# 2668 "lib/CParser.ml"
     : (unit))

let _menhir_print_token : token -> string =
  fun _tok ->
    match _tok with
    | ADD ->
        "ADD"
    | ATOMIC ->
        "ATOMIC"
    | ATOMICADDUNLESS ->
        "ATOMICADDUNLESS"
    | ATOMIC_BASE ->
        "ATOMIC_BASE"
    | ATOMIC_FETCH_EXPLICIT _ ->
        "ATOMIC_FETCH_EXPLICIT"
    | ATOMIC_TYPE _ ->
        "ATOMIC_TYPE"
    | BASE_TYPE _ ->
        "BASE_TYPE"
    | BODY _ ->
        "BODY"
    | CHAR ->
        "CHAR"
    | CMPXCHG ->
        "CMPXCHG"
    | CODEVAR _ ->
        "CODEVAR"
    | COLON ->
        "COLON"
    | COMMA ->
        "COMMA"
    | CONST ->
        "CONST"
    | CONSTANT _ ->
        "CONSTANT"
    | CONSTVAR _ ->
        "CONSTVAR"
    | DIV ->
        "DIV"
    | ELSE ->
        "ELSE"
    | EOF ->
        "EOF"
    | EQ ->
        "EQ"
    | EQ_OP ->
        "EQ_OP"
    | EXC_EXPLICIT ->
        "EXC_EXPLICIT"
    | FENCE ->
        "FENCE"
    | GE ->
        "GE"
    | GT ->
        "GT"
    | IF ->
        "IF"
    | INT ->
        "INT"
    | LAND ->
        "LAND"
    | LBRACE ->
        "LBRACE"
    | LD_EXPLICIT ->
        "LD_EXPLICIT"
    | LE ->
        "LE"
    | LEVELS ->
        "LEVELS"
    | LOAD ->
        "LOAD"
    | LOCK ->
        "LOCK"
    | LONG ->
        "LONG"
    | LPAR ->
        "LPAR"
    | LT ->
        "LT"
    | MEMORDER _ ->
        "MEMORDER"
    | MUTEX ->
        "MUTEX"
    | NAME _ ->
        "NAME"
    | NEQ_OP ->
        "NEQ_OP"
    | NUM _ ->
        "NUM"
    | PIPE ->
        "PIPE"
    | PROC _ ->
        "PROC"
    | RBRACE ->
        "RBRACE"
    | REGIONS ->
        "REGIONS"
    | RPAR ->
        "RPAR"
    | SCAS ->
        "SCAS"
    | SCAS_EXPLICIT ->
        "SCAS_EXPLICIT"
    | SCOPES ->
        "SCOPES"
    | SEMI ->
        "SEMI"
    | SPINISLOCKED ->
        "SPINISLOCKED"
    | SPINLOCK ->
        "SPINLOCK"
    | SPINTRYLOCK ->
        "SPINTRYLOCK"
    | SPINUNLOCK ->
        "SPINUNLOCK"
    | SRCU ->
        "SRCU"
    | STAR ->
        "STAR"
    | STORE ->
        "STORE"
    | STRUCT ->
        "STRUCT"
    | STRUCT_TYPE _ ->
        "STRUCT_TYPE"
    | ST_EXPLICIT ->
        "ST_EXPLICIT"
    | SUB ->
        "SUB"
    | UNDERATOMICADDUNLESS ->
        "UNDERATOMICADDUNLESS"
    | UNDERATOMICFETCHOP ->
        "UNDERATOMICFETCHOP"
    | UNDERATOMICOP ->
        "UNDERATOMICOP"
    | UNDERATOMICOPRETURN ->
        "UNDERATOMICOPRETURN"
    | UNDERFENCE ->
        "UNDERFENCE"
    | UNLOCK ->
        "UNLOCK"
    | VOID ->
        "VOID"
    | VOLATILE ->
        "VOLATILE"
    | WCAS ->
        "WCAS"
    | WCAS_EXPLICIT ->
        "WCAS_EXPLICIT"
    | WHILE ->
        "WHILE"
    | XCHG ->
        "XCHG"
    | XOR ->
        "XOR"

let _menhir_fail : unit -> 'a =
  fun () ->
    Printf.eprintf "Internal failure -- please contact the parser generator's developers.\n%!";
    assert false

include struct
  
  [@@@ocaml.warning "-4-37"]
  
  let _menhir_run_495 : type  ttv_stack. ttv_stack -> _ -> _menhir_box_shallow_main =
    fun _menhir_stack _v ->
      MenhirBox_shallow_main _v
  
  let rec _menhir_goto_shallow_main : type  ttv_stack. ttv_stack -> _ -> (ttv_stack, _menhir_box_shallow_main) _menhir_state -> _menhir_box_shallow_main =
    fun _menhir_stack _v _menhir_s ->
      match _menhir_s with
      | MenhirState483 ->
          _menhir_run_495 _menhir_stack _v
      | MenhirState484 ->
          _menhir_run_494 _menhir_stack _v
      | MenhirState490 ->
          _menhir_run_491 _menhir_stack _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_494 : type  ttv_stack. (ttv_stack, _menhir_box_shallow_main) _menhir_cell1_BODY -> _ -> _menhir_box_shallow_main =
    fun _menhir_stack _v ->
      let MenhirCell1_BODY (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_164 _1 _2 in
      _menhir_goto_shallow_main _menhir_stack _v _menhir_s
  
  and _menhir_run_491 : type  ttv_stack. ((ttv_stack, _menhir_box_shallow_main) _menhir_cell1_voidopt _menhir_cell0_PROC, _menhir_box_shallow_main) _menhir_cell1_parameter_list _menhir_cell0_BODY -> _ -> _menhir_box_shallow_main =
    fun _menhir_stack _v ->
      let MenhirCell0_BODY (_menhir_stack, _6) = _menhir_stack in
      let MenhirCell1_parameter_list (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell0_PROC (_menhir_stack, _2) = _menhir_stack in
      let MenhirCell1_voidopt (_menhir_stack, _menhir_s, _) = _menhir_stack in
      let _7 = _v in
      let _v = _menhir_action_165 _2 _4 _6 _7 in
      _menhir_goto_shallow_main _menhir_stack _v _menhir_s
  
  let _menhir_run_492 : type  ttv_stack. ttv_stack -> _ -> (ttv_stack, _menhir_box_shallow_main) _menhir_state -> _ -> _menhir_box_shallow_main =
    fun _menhir_stack _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | EOF ->
          let _1 = _v in
          let _v = _menhir_action_163 _1 in
          _menhir_goto_shallow_main _menhir_stack _v _menhir_s
      | _ ->
          _eRR ()
  
  let _menhir_run_444 : type  ttv_stack. (ttv_stack, _menhir_box_deep_main) _menhir_cell1_trans_unit -> _ -> _ -> _menhir_box_deep_main =
    fun _menhir_stack _v _tok ->
      match (_tok : MenhirBasics.token) with
      | EOF ->
          let MenhirCell1_trans_unit (_menhir_stack, _, _1) = _menhir_stack in
          let _2 = _v in
          let _v = _menhir_action_032 _1 _2 in
          MenhirBox_deep_main _v
      | _ ->
          _eRR ()
  
  let _menhir_goto_scopes_and_memory_map : type  ttv_stack ttv_result. ttv_stack -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState483 ->
          _menhir_run_492 _menhir_stack _v _menhir_s _tok
      | MenhirState484 ->
          _menhir_run_492 _menhir_stack _v _menhir_s _tok
      | MenhirState490 ->
          _menhir_run_492 _menhir_stack _v _menhir_s _tok
      | MenhirState397 ->
          _menhir_run_444 _menhir_stack _v _tok
      | _ ->
          _menhir_fail ()
  
  let _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ : type  ttv_stack ttv_result. ttv_stack -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _v _menhir_s _tok ->
      let x = _v in
      let _v = _menhir_action_159 x in
      _menhir_goto_scopes_and_memory_map _menhir_stack _v _menhir_s _tok
  
  let _menhir_run_456 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_levels_key, ttv_result) _menhir_cell1_memory_map_key -> _ -> _ -> ttv_result =
    fun _menhir_stack _v _tok ->
      let MenhirCell1_memory_map_key (_menhir_stack, _, regions) = _menhir_stack in
      let MenhirCell1_levels_key (_menhir_stack, _menhir_s, levels) = _menhir_stack in
      let scopes = _v in
      let _v = _menhir_action_137 levels regions scopes in
      _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
  
  let _menhir_run_454 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_levels_key, ttv_result) _menhir_cell1_scopes_key -> _ -> _ -> ttv_result =
    fun _menhir_stack _v _tok ->
      let MenhirCell1_scopes_key (_menhir_stack, _, scopes) = _menhir_stack in
      let MenhirCell1_levels_key (_menhir_stack, _menhir_s, levels) = _menhir_stack in
      let regions = _v in
      let _v = _menhir_action_135 levels regions scopes in
      _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
  
  let _menhir_run_449 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_memory_map_key, ttv_result) _menhir_cell1_scopes_key -> _ -> _ -> ttv_result =
    fun _menhir_stack _v _tok ->
      let MenhirCell1_scopes_key (_menhir_stack, _, scopes) = _menhir_stack in
      let MenhirCell1_memory_map_key (_menhir_stack, _menhir_s, regions) = _menhir_stack in
      let levels = _v in
      let _v = _menhir_action_138 levels regions scopes in
      _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
  
  let _menhir_run_441 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_scopes_key, ttv_result) _menhir_cell1_memory_map_key -> _ -> _ -> ttv_result =
    fun _menhir_stack _v _tok ->
      let MenhirCell1_memory_map_key (_menhir_stack, _, regions) = _menhir_stack in
      let MenhirCell1_scopes_key (_menhir_stack, _menhir_s, scopes) = _menhir_stack in
      let levels = _v in
      let _v = _menhir_action_139 levels regions scopes in
      _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
  
  let _menhir_run_443 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_scopes_key, ttv_result) _menhir_cell1_levels_key -> _ -> _ -> ttv_result =
    fun _menhir_stack _v _tok ->
      let MenhirCell1_levels_key (_menhir_stack, _, levels) = _menhir_stack in
      let MenhirCell1_scopes_key (_menhir_stack, _menhir_s, scopes) = _menhir_stack in
      let regions = _v in
      let _v = _menhir_action_134 levels regions scopes in
      _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
  
  let _menhir_run_451 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_memory_map_key, ttv_result) _menhir_cell1_levels_key -> _ -> _ -> ttv_result =
    fun _menhir_stack _v _tok ->
      let MenhirCell1_levels_key (_menhir_stack, _, levels) = _menhir_stack in
      let MenhirCell1_memory_map_key (_menhir_stack, _menhir_s, regions) = _menhir_stack in
      let scopes = _v in
      let _v = _menhir_action_136 levels regions scopes in
      _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
  
  let rec _menhir_run_398 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SCOPES (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _menhir_s = MenhirState399 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LPAR ->
              _menhir_run_400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_400 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _menhir_stack = MenhirCell0_NAME (_menhir_stack, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | PROC _v_0 ->
              _menhir_run_402 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState401
          | NUM _v_1 ->
              _menhir_run_403 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState401
          | LPAR ->
              _menhir_run_400 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState401
          | RPAR ->
              let _v_2 = _menhir_action_153 () in
              _menhir_run_408 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_402 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_150 _1 in
      _menhir_goto_proc _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_proc : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_proc (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | PROC _v_0 ->
          _menhir_run_402 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState410
      | NUM _v_1 ->
          _menhir_run_403 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState410
      | RPAR ->
          let _v_2 = _menhir_action_153 () in
          _menhir_run_411 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2
      | _ ->
          _eRR ()
  
  and _menhir_run_403 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_151 _1 in
      _menhir_goto_proc _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_411 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_proc -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_proc (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_152 _1 _2 in
      _menhir_goto_proc_list_sc _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_proc_list_sc : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState410 ->
          _menhir_run_411 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState401 ->
          _menhir_run_408 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_408 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LPAR _menhir_cell0_NAME -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell0_NAME (_menhir_stack, _2) = _menhir_stack in
      let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_156 _2 _3 in
      _menhir_goto_scope_tree _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_scope_tree : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_stack = MenhirCell1_scope_tree (_menhir_stack, _menhir_s, _v) in
          _menhir_run_400 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState406
      | EOF | LEVELS | REGIONS | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_157 _1 in
          _menhir_goto_scope_tree_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_scope_tree_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState399 ->
          _menhir_run_413 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState406 ->
          _menhir_run_407 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState401 ->
          _menhir_run_404 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_413 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_SCOPES -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _1 = _v in
      let _v = _menhir_action_168 _1 in
      let MenhirCell1_SCOPES (_menhir_stack, _menhir_s) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_160 _3 in
      _menhir_goto_scopes_key _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_scopes_key : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState455 ->
          _menhir_run_456 _menhir_stack _v _tok
      | MenhirState452 ->
          _menhir_run_453 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState450 ->
          _menhir_run_451 _menhir_stack _v _tok
      | MenhirState447 ->
          _menhir_run_448 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState483 ->
          _menhir_run_439 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState484 ->
          _menhir_run_439 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState490 ->
          _menhir_run_439 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState397 ->
          _menhir_run_439 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_453 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_levels_key as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | REGIONS ->
          let _menhir_stack = MenhirCell1_scopes_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState453
      | EOF ->
          let MenhirCell1_levels_key (_menhir_stack, _menhir_s, levels) = _menhir_stack in
          let scopes = _v in
          let _v = _menhir_action_141 levels scopes in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_414 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_REGIONS (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _menhir_s = MenhirState415 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v ->
              _menhir_run_416 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EOF | LEVELS | SCOPES ->
              let _v = _menhir_action_121 () in
              _menhir_goto_loption_separated_nonempty_list_COMMA_memory_map_atom__ _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_416 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_NAME (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _menhir_s = MenhirState417 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v ->
              _menhir_run_418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_418 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v_0 ->
          let _menhir_stack = MenhirCell1_NAME (_menhir_stack, _menhir_s, _v) in
          _menhir_run_418 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState418
      | COMMA | EOF | LEVELS | SCOPES ->
          let x = _v in
          let _v = _menhir_action_128 x in
          _menhir_goto_nonempty_list_NAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_nonempty_list_NAME_ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState417 ->
          _menhir_run_420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState418 ->
          _menhir_run_419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_420 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_NAME -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_NAME (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_126 _1 _3 in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_memory_map_atom (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState424 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v ->
              _menhir_run_416 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | EOF | LEVELS | SCOPES ->
          let x = _v in
          let _v = _menhir_action_161 x in
          _menhir_goto_separated_nonempty_list_COMMA_memory_map_atom_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_goto_separated_nonempty_list_COMMA_memory_map_atom_ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState424 ->
          _menhir_run_425 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState415 ->
          _menhir_run_422 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_425 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_memory_map_atom -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_memory_map_atom (_menhir_stack, _menhir_s, x) = _menhir_stack in
      let xs = _v in
      let _v = _menhir_action_162 x xs in
      _menhir_goto_separated_nonempty_list_COMMA_memory_map_atom_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_422 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_REGIONS -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let x = _v in
      let _v = _menhir_action_122 x in
      _menhir_goto_loption_separated_nonempty_list_COMMA_memory_map_atom__ _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_goto_loption_separated_nonempty_list_COMMA_memory_map_atom__ : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_REGIONS -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let xs = _v in
      let _v = _menhir_action_167 xs in
      let MenhirCell1_REGIONS (_menhir_stack, _menhir_s) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_127 _3 in
      _menhir_goto_memory_map_key _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_memory_map_key : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState452 ->
          _menhir_run_455 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState453 ->
          _menhir_run_454 _menhir_stack _v _tok
      | MenhirState483 ->
          _menhir_run_447 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState484 ->
          _menhir_run_447 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState490 ->
          _menhir_run_447 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState397 ->
          _menhir_run_447 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState442 ->
          _menhir_run_443 _menhir_stack _v _tok
      | MenhirState439 ->
          _menhir_run_440 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_455 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_levels_key as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SCOPES ->
          let _menhir_stack = MenhirCell1_memory_map_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_398 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | EOF ->
          let MenhirCell1_levels_key (_menhir_stack, _menhir_s, levels) = _menhir_stack in
          let regions = _v in
          let _v = _menhir_action_144 levels regions in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_447 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SCOPES ->
          let _menhir_stack = MenhirCell1_memory_map_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_398 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState447
      | LEVELS ->
          let _menhir_stack = MenhirCell1_memory_map_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState447
      | EOF ->
          let regions = _v in
          let _v = _menhir_action_148 regions in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_427 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LEVELS (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _menhir_s = MenhirState428 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | PROC _v ->
              _menhir_run_429 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_429 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | PROC _v_0 ->
          let _menhir_stack = MenhirCell1_PROC (_menhir_stack, _menhir_s, _v) in
          _menhir_run_429 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState429
      | LPAR ->
          let _menhir_stack = MenhirCell1_PROC (_menhir_stack, _menhir_s, _v) in
          _menhir_run_430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState429
      | EOF | REGIONS | RPAR | SCOPES ->
          let _1 = _v in
          let _v = _menhir_action_111 _1 in
          _menhir_goto_level_tree_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_430 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          let _menhir_stack = MenhirCell0_NAME (_menhir_stack, _v) in
          let _menhir_s = MenhirState431 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | PROC _v ->
              _menhir_run_429 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_goto_level_tree_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState428 ->
          _menhir_run_438 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState429 ->
          _menhir_run_436 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState434 ->
          _menhir_run_435 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState431 ->
          _menhir_run_432 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_438 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LEVELS -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _1 = _v in
      let _v = _menhir_action_166 _1 in
      let MenhirCell1_LEVELS (_menhir_stack, _menhir_s) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_115 _3 in
      _menhir_goto_levels_key _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_levels_key : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState483 ->
          _menhir_run_452 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState484 ->
          _menhir_run_452 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState490 ->
          _menhir_run_452 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState397 ->
          _menhir_run_452 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState447 ->
          _menhir_run_450 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState448 ->
          _menhir_run_449 _menhir_stack _v _tok
      | MenhirState439 ->
          _menhir_run_442 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState440 ->
          _menhir_run_441 _menhir_stack _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_452 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SCOPES ->
          let _menhir_stack = MenhirCell1_levels_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_398 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState452
      | REGIONS ->
          let _menhir_stack = MenhirCell1_levels_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState452
      | EOF ->
          let levels = _v in
          let _v = _menhir_action_147 levels in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_450 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_memory_map_key as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SCOPES ->
          let _menhir_stack = MenhirCell1_levels_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_398 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState450
      | EOF ->
          let MenhirCell1_memory_map_key (_menhir_stack, _menhir_s, regions) = _menhir_stack in
          let levels = _v in
          let _v = _menhir_action_145 levels regions in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_442 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_scopes_key as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | REGIONS ->
          let _menhir_stack = MenhirCell1_levels_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState442
      | EOF ->
          let MenhirCell1_scopes_key (_menhir_stack, _menhir_s, scopes) = _menhir_stack in
          let levels = _v in
          let _v = _menhir_action_140 levels scopes in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_436 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_PROC -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_PROC (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_113 _1 _2 in
      _menhir_goto_level_tree_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_435 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_level_tree -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_level_tree (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_114 _1 _2 in
      _menhir_goto_level_tree_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_432 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LPAR _menhir_cell0_NAME -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_NAME (_menhir_stack, _2) = _menhir_stack in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_110 _2 _3 in
          (match (_tok : MenhirBasics.token) with
          | PROC _v_0 ->
              let _menhir_stack = MenhirCell1_level_tree (_menhir_stack, _menhir_s, _v) in
              _menhir_run_429 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState434
          | LPAR ->
              let _menhir_stack = MenhirCell1_level_tree (_menhir_stack, _menhir_s, _v) in
              _menhir_run_430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState434
          | EOF | REGIONS | RPAR | SCOPES ->
              let _1 = _v in
              let _v = _menhir_action_112 _1 in
              _menhir_goto_level_tree_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_440 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_scopes_key as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | LEVELS ->
          let _menhir_stack = MenhirCell1_memory_map_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState440
      | EOF ->
          let MenhirCell1_scopes_key (_menhir_stack, _menhir_s, scopes) = _menhir_stack in
          let regions = _v in
          let _v = _menhir_action_142 regions scopes in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_419 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_NAME -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_NAME (_menhir_stack, _menhir_s, x) = _menhir_stack in
      let xs = _v in
      let _v = _menhir_action_129 x xs in
      _menhir_goto_nonempty_list_NAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_448 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_memory_map_key as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | LEVELS ->
          let _menhir_stack = MenhirCell1_scopes_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState448
      | EOF ->
          let MenhirCell1_memory_map_key (_menhir_stack, _menhir_s, regions) = _menhir_stack in
          let scopes = _v in
          let _v = _menhir_action_143 regions scopes in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_439 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | REGIONS ->
          let _menhir_stack = MenhirCell1_scopes_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState439
      | LEVELS ->
          let _menhir_stack = MenhirCell1_scopes_key (_menhir_stack, _menhir_s, _v) in
          _menhir_run_427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState439
      | EOF ->
          let scopes = _v in
          let _v = _menhir_action_146 scopes in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_407 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_scope_tree -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_scope_tree (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_158 _1 _2 in
      _menhir_goto_scope_tree_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_404 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LPAR _menhir_cell0_NAME -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_NAME (_menhir_stack, _2) = _menhir_stack in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_155 _2 _3 in
          _menhir_goto_scope_tree _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  let _menhir_run_481 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_pseudo_seq =
    fun _menhir_stack _v _tok ->
      match (_tok : MenhirBasics.token) with
      | EOF ->
          let p = _v in
          let _v = _menhir_action_154 p in
          MenhirBox_pseudo_seq _v
      | _ ->
          _eRR ()
  
  let _menhir_run_477 : type  ttv_stack. ttv_stack -> _ -> _menhir_box_macros =
    fun _menhir_stack _v ->
      let ms = _v in
      let _v = _menhir_action_125 ms in
      MenhirBox_macros _v
  
  let rec _menhir_run_476 : type  ttv_stack. (ttv_stack, _menhir_box_macros) _menhir_cell1_macro -> _ -> _menhir_box_macros =
    fun _menhir_stack _v ->
      let MenhirCell1_macro (_menhir_stack, _menhir_s, x) = _menhir_stack in
      let xs = _v in
      let _v = _menhir_action_117 x xs in
      _menhir_goto_list_macro_ _menhir_stack _v _menhir_s
  
  and _menhir_goto_list_macro_ : type  ttv_stack. ttv_stack -> _ -> (ttv_stack, _menhir_box_macros) _menhir_state -> _menhir_box_macros =
    fun _menhir_stack _v _menhir_s ->
      match _menhir_s with
      | MenhirState460 ->
          _menhir_run_477 _menhir_stack _v
      | MenhirState475 ->
          _menhir_run_476 _menhir_stack _v
      | _ ->
          _menhir_fail ()
  
  let rec _menhir_run_001 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v = _menhir_action_185 () in
          _menhir_goto_voidopt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PROC _ ->
          let _v = _menhir_action_184 () in
          _menhir_goto_voidopt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_voidopt : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState483 ->
          _menhir_run_485 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState490 ->
          _menhir_run_485 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState484 ->
          _menhir_run_485 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState397 ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState000 ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_485 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_shallow_main) _menhir_state -> _ -> _menhir_box_shallow_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_voidopt (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | PROC _v_0 ->
          let _menhir_stack = MenhirCell0_PROC (_menhir_stack, _v_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LPAR ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VOLATILE ->
                  _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState487
              | VOID ->
                  _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState487
              | STRUCT ->
                  _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState487
              | LPAR ->
                  _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState487
              | CONST ->
                  _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState487
              | BASE_TYPE _v_1 ->
                  _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState487
              | ATOMIC_TYPE _v_2 ->
                  _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState487
              | ATOMIC_BASE ->
                  _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState487
              | ATOMIC ->
                  _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState487
              | RPAR ->
                  let _v_3 = _menhir_action_131 () in
                  _menhir_run_488 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState487
              | CHAR | INT | LONG | MUTEX ->
                  let _menhir_s = MenhirState487 in
                  let _v = _menhir_action_171 () in
                  _menhir_goto_ty_attr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_006 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_VOLATILE (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState006 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | STRUCT ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_TYPE _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_TYPE _v ->
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_BASE ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR | INT | LONG | MUTEX ->
          _menhir_reduce_171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_007 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | STRUCT_TYPE _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _2 = _v in
          let _v = _menhir_action_023 _2 in
          _menhir_goto_base0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_base0 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState487 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState479 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState469 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState005 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState395 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState046 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState390 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState392 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState260 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState354 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState383 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState385 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState358 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState376 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState344 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState307 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState074 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState090 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState091 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState009 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState011 ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState006 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState026 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState012 ->
          _menhir_run_024 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_037 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_178 _1 in
      _menhir_goto_typ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_typ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState479 ->
          _menhir_run_378 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState469 ->
          _menhir_run_378 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState392 ->
          _menhir_run_378 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState390 ->
          _menhir_run_378 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState046 ->
          _menhir_run_378 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState385 ->
          _menhir_run_378 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState383 ->
          _menhir_run_378 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState354 ->
          _menhir_run_378 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState260 ->
          _menhir_run_366 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState376 ->
          _menhir_run_366 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState358 ->
          _menhir_run_366 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState307 ->
          _menhir_run_211 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState074 ->
          _menhir_run_211 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState090 ->
          _menhir_run_181 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState344 ->
          _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState091 ->
          _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState487 ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState395 ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState005 ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState009 ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState011 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_378 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NAME _v_0 ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SEMI ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_1, _2) = (_v, _v_0) in
              let _v = _menhir_action_031 _1 _2 in
              _menhir_goto_declaration _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | EQ ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              let _menhir_stack = MenhirCell0_NAME (_menhir_stack, _v_0) in
              _menhir_run_368 _menhir_stack _menhir_lexbuf _menhir_lexer
          | _ ->
              _eRR ())
      | CONST | VOLATILE ->
          let t = _v in
          let _v = _menhir_action_179 t in
          _menhir_goto_typ_par _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_035 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_typ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_typ (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _v = _menhir_action_181 _1 in
      _menhir_goto_typ_ptr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_typ_ptr : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState487 ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState395 ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState005 ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState479 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState469 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState392 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState390 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState046 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState260 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState385 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState383 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState354 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState376 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState358 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState344 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState307 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState074 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState090 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState091 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState009 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState011 ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_041 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | NAME _v_0 ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_1, _2) = (_v, _v_0) in
          let _v = _menhir_action_130 _1 _2 in
          (match (_tok : MenhirBasics.token) with
          | COMMA ->
              let _menhir_stack = MenhirCell1_parameter_declaration (_menhir_stack, _menhir_s, _v) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VOLATILE ->
                  _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
              | VOID ->
                  _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
              | STRUCT ->
                  _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
              | LPAR ->
                  _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
              | CONST ->
                  _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
              | BASE_TYPE _v_0 ->
                  _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState395
              | ATOMIC_TYPE _v_1 ->
                  _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState395
              | ATOMIC_BASE ->
                  _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
              | ATOMIC ->
                  _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState395
              | RPAR ->
                  let _v_2 = _menhir_action_131 () in
                  _menhir_run_396 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2
              | CHAR | INT | LONG | MUTEX ->
                  let _menhir_s = MenhirState395 in
                  let _v = _menhir_action_171 () in
                  _menhir_goto_ty_attr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
              | _ ->
                  _eRR ())
          | RPAR ->
              let _1 = _v in
              let _v = _menhir_action_132 _1 in
              _menhir_goto_parameter_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | CONST | STAR | VOLATILE ->
          let _1 = _v in
          let _v = _menhir_action_172 _1 in
          _menhir_goto_typ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_010 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_183 () in
      _menhir_goto_void _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_void : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v in
          let _v = _menhir_action_182 _1 in
          _menhir_goto_typ_ptr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_011 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState011 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOLATILE ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_TYPE _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_TYPE _v ->
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_BASE ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR | INT | LONG | MUTEX ->
          _menhir_reduce_171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_012 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_CONST (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState012 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | STRUCT ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_TYPE _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_TYPE _v ->
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_BASE ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR | INT | LONG | MUTEX ->
          _menhir_reduce_171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_009 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState009 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOLATILE ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_TYPE _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_TYPE _v ->
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_BASE ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR | INT | LONG | MUTEX ->
          _menhir_reduce_171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_013 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_022 _1 in
      _menhir_goto_base0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_014 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_020 _1 in
      _menhir_goto_base0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_015 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LT ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | BASE_TYPE _v ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | GT ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let _3 = _v in
                  let _v = _menhir_action_021 _3 in
                  _menhir_goto_base0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_026 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_ATOMIC (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState026 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | STRUCT ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_TYPE _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_TYPE _v ->
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_BASE ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR | INT | LONG | MUTEX ->
          _menhir_reduce_171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_reduce_171 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok ->
      let _v = _menhir_action_171 () in
      _menhir_goto_ty_attr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_ty_attr : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | MUTEX ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v in
          let _v = _menhir_action_024 _1 in
          _menhir_goto_base0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | LONG ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v in
          let _v = _menhir_action_027 _1 in
          _menhir_goto_base0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | INT ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v in
          let _v = _menhir_action_026 _1 in
          _menhir_goto_base0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | CHAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v in
          let _v = _menhir_action_025 _1 in
          _menhir_goto_base0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_396 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_parameter_declaration -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_parameter_declaration (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_133 _1 _3 in
      _menhir_goto_parameter_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_parameter_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState487 ->
          _menhir_run_488 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState395 ->
          _menhir_run_396 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState005 ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_488 : type  ttv_stack. ((ttv_stack, _menhir_box_shallow_main) _menhir_cell1_voidopt _menhir_cell0_PROC as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_shallow_main) _menhir_state -> _menhir_box_shallow_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_parameter_list (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | BODY _v_0 ->
          let _menhir_stack = MenhirCell0_BODY (_menhir_stack, _v_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VOID ->
              _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState490
          | SCOPES ->
              _menhir_run_398 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState490
          | REGIONS ->
              _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState490
          | LEVELS ->
              _menhir_run_427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState490
          | BODY _v_1 ->
              _menhir_run_484 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState490
          | EOF ->
              let _menhir_s = MenhirState490 in
              let _v = _menhir_action_149 () in
              _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
          | PROC _ ->
              let _v_3 = _menhir_action_186 () in
              _menhir_run_485 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState490 _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_484 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_shallow_main) _menhir_state -> _menhir_box_shallow_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_BODY (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState484
      | SCOPES ->
          _menhir_run_398 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState484
      | REGIONS ->
          _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState484
      | LEVELS ->
          _menhir_run_427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState484
      | BODY _v_0 ->
          _menhir_run_484 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState484
      | EOF ->
          let _menhir_s = MenhirState484 in
          let _v = _menhir_action_149 () in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
      | PROC _ ->
          let _v_2 = _menhir_action_186 () in
          _menhir_run_485 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState484 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_044 : type  ttv_stack. ((ttv_stack, _menhir_box_deep_main) _menhir_cell1_voidopt _menhir_cell0_PROC as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_deep_main) _menhir_state -> _menhir_box_deep_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_parameter_list (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          let _menhir_s = MenhirState046 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WHILE ->
              _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNLOCK ->
              _menhir_run_261 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERFENCE ->
              _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOP ->
              _menhir_run_271 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ST_EXPLICIT ->
              _menhir_run_280 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STORE ->
              _menhir_run_289 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_299 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_314 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINUNLOCK ->
              _menhir_run_326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINLOCK ->
              _menhir_run_331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_336 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOCK ->
              _menhir_run_349 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              _menhir_run_354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              _menhir_run_355 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FENCE ->
              _menhir_run_359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONST ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CODEVAR _v ->
              _menhir_run_364 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_TYPE _v ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_TYPE _v ->
              _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR | INT | LONG | MUTEX ->
              _menhir_reduce_171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_047 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_XCHG (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          let _menhir_s = MenhirState048 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UNLOCK ->
              _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LOCK ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_049 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_007 () in
      _menhir_goto_annot_base _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_annot_base : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SUB ->
          let _menhir_stack = MenhirCell1_annot_base (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState159 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UNLOCK ->
              _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LOCK ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COMMA | RBRACE ->
          let _1 = _v in
          let _v = _menhir_action_004 _1 in
          _menhir_goto_annot _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_050 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_009 _1 in
      _menhir_goto_annot_base _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_051 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_006 () in
      _menhir_goto_annot_base _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_052 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_008 () in
      _menhir_goto_annot_base _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_annot : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState315 ->
          _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState290 ->
          _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState267 ->
          _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState048 ->
          _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState061 ->
          _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState066 ->
          _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState076 ->
          _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState093 ->
          _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState162 ->
          _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState104 ->
          _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState159 ->
          _menhir_run_160 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_161 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_annot (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState162 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UNLOCK ->
              _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LOCK ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | RBRACE ->
          let _1 = _v in
          let _v = _menhir_action_011 _1 in
          _menhir_goto_annot_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_goto_annot_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState315 ->
          _menhir_run_316 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState290 ->
          _menhir_run_291 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState267 ->
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState162 ->
          _menhir_run_163 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState104 ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState093 ->
          _menhir_run_094 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState076 ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState066 ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState061 ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState048 ->
          _menhir_run_053 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_316 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_SRCU as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_annot_list (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState318 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_056 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_WCAS_EXPLICIT (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState057 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_058 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_WCAS (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState059 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_060 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_UNDERATOMICOPRETURN (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          let _menhir_s = MenhirState061 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UNLOCK ->
              _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LOCK ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_065 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_UNDERATOMICFETCHOP (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          let _menhir_s = MenhirState066 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UNLOCK ->
              _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LOCK ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_070 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_UNDERATOMICADDUNLESS (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState071 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_072 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_STAR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState072 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | LPAR ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
          let _menhir_s = MenhirState074 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONST ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_TYPE _v ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_TYPE _v ->
              _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR | INT | LONG | MUTEX ->
              _menhir_reduce_171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_073 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_STAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_STAR (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_042 _2 in
      _menhir_goto_expr0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_expr0 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState256 ->
          _menhir_run_260 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState479 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState468 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState469 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState392 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState390 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState046 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState260 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState385 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState383 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState354 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState376 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState358 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState368 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState356 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState350 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState344 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState346 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState341 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState337 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState332 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState327 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState322 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState318 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState311 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState307 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState302 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState295 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState293 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState283 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState281 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState276 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState272 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState262 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState259 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState253 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState055 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState245 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState243 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState057 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState239 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState237 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState059 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState233 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState064 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState227 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState069 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState219 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState217 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState071 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState074 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState079 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState081 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState083 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState198 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState196 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState085 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState192 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState190 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState087 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState184 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState089 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState090 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState182 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState091 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState177 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState096 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState098 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState165 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState100 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState155 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState153 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState107 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState147 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState109 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState143 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState141 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState139 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState137 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState135 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState133 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState131 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState129 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState127 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState125 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState123 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState121 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState119 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState117 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState115 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState111 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_260 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_WHILE as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr0 (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | WHILE ->
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | VOLATILE ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | VOID ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | UNLOCK ->
          _menhir_run_261 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | UNDERFENCE ->
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | UNDERATOMICOP ->
          _menhir_run_271 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | ST_EXPLICIT ->
          _menhir_run_280 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | STRUCT ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | STORE ->
          _menhir_run_289 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | STAR ->
          _menhir_run_299 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | SRCU ->
          _menhir_run_314 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | SPINUNLOCK ->
          _menhir_run_326 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | SPINTRYLOCK ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | SPINLOCK ->
          _menhir_run_331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | SPINISLOCKED ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | SCAS_EXPLICIT ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | SCAS ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | NAME _v_0 ->
          _menhir_run_336 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState260
      | LPAR ->
          _menhir_run_344 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | LOCK ->
          _menhir_run_349 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | LOAD ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | LD_EXPLICIT ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | LBRACE ->
          _menhir_run_354 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | IF ->
          _menhir_run_355 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | FENCE ->
          _menhir_run_359 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | EXC_EXPLICIT ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | CONSTVAR _v_1 ->
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState260
      | CONSTANT _v_2 ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState260
      | CONST ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | CODEVAR _v_3 ->
          _menhir_run_364 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState260
      | CMPXCHG ->
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | BASE_TYPE _v_4 ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState260
      | ATOMIC_TYPE _v_5 ->
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState260
      | ATOMIC_FETCH_EXPLICIT _v_6 ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState260
      | ATOMIC_BASE ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | ATOMICADDUNLESS ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | ATOMIC ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState260
      | CHAR | INT | LONG | MUTEX ->
          let _menhir_s = MenhirState260 in
          let _v = _menhir_action_171 () in
          _menhir_goto_ty_attr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_256 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_WHILE (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_STAR (_menhir_stack, MenhirState256) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v ->
              _menhir_run_073 _menhir_stack _menhir_lexbuf _menhir_lexer _v
          | _ ->
              _eRR ())
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v =
            let _1 = _v in
            _menhir_action_041 _1
          in
          _menhir_run_260 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState256 _tok
      | LPAR ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, MenhirState256) in
          let _menhir_s = MenhirState259 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | CONSTVAR _v ->
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState256
      | CONSTANT _v ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState256
      | _ ->
          _eRR ()
  
  and _menhir_run_075 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SRCU (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          let _menhir_s = MenhirState076 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UNLOCK ->
              _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LOCK ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_080 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SPINTRYLOCK (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState081 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_082 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SPINISLOCKED (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState083 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_084 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SCAS_EXPLICIT (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState085 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_086 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SCAS (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState087 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_088 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_stack = MenhirCell1_NAME (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState089
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState089
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState089
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState089
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState089
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState089
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState089
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState089
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState089
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState089
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState089
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState089
          | NAME _v_0 ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState089
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState089
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState089
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState089
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState089
          | CONSTVAR _v_1 ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState089
          | CONSTANT _v_2 ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState089
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState089
          | ATOMIC_FETCH_EXPLICIT _v_3 ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState089
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState089
          | RPAR ->
              let _v_4 = _menhir_action_012 () in
              _menhir_run_187 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4
          | _ ->
              _eRR ())
      | ADD | COMMA | DIV | EOF | EQ_OP | GE | GT | LAND | LE | LT | NAME _ | NEQ_OP | PIPE | RPAR | SEMI | STAR | SUB | XOR ->
          let _1 = _v in
          let _v = _menhir_action_041 _1 in
          _menhir_goto_expr0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_090 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState090 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONST ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CMPXCHG ->
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_TYPE _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_TYPE _v ->
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_BASE ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMICADDUNLESS ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR | INT | LONG | MUTEX ->
          _menhir_reduce_171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_091 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState091 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONST ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CMPXCHG ->
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_TYPE _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_TYPE _v ->
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_BASE ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMICADDUNLESS ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR | INT | LONG | MUTEX ->
          _menhir_reduce_171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_092 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LOAD (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          let _menhir_s = MenhirState093 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UNLOCK ->
              _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LOCK ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_097 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LD_EXPLICIT (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState098 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_099 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_EXC_EXPLICIT (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState100 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_101 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_040 _1 in
      _menhir_goto_expr0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_102 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_039 _1 in
      _menhir_goto_expr0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_103 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_CMPXCHG (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          let _menhir_s = MenhirState104 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UNLOCK ->
              _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LOCK ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_108 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_ATOMIC_FETCH_EXPLICIT (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState109 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_110 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_ATOMICADDUNLESS (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState111 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_187 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_NAME -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_NAME (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_067 _1 _3 in
      _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_expr1 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_038 _1 in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_expr : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState468 ->
          _menhir_run_472 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState479 ->
          _menhir_run_374 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState469 ->
          _menhir_run_374 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState392 ->
          _menhir_run_374 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState390 ->
          _menhir_run_374 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState046 ->
          _menhir_run_374 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState260 ->
          _menhir_run_374 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState385 ->
          _menhir_run_374 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState383 ->
          _menhir_run_374 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState354 ->
          _menhir_run_374 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState376 ->
          _menhir_run_374 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState358 ->
          _menhir_run_374 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState368 ->
          _menhir_run_369 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState356 ->
          _menhir_run_357 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState350 ->
          _menhir_run_351 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState346 ->
          _menhir_run_347 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState341 ->
          _menhir_run_342 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState332 ->
          _menhir_run_333 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState327 ->
          _menhir_run_328 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState322 ->
          _menhir_run_323 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState318 ->
          _menhir_run_319 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState311 ->
          _menhir_run_312 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState307 ->
          _menhir_run_308 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState302 ->
          _menhir_run_303 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState295 ->
          _menhir_run_296 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState293 ->
          _menhir_run_294 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState283 ->
          _menhir_run_284 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState281 ->
          _menhir_run_282 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState276 ->
          _menhir_run_277 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState272 ->
          _menhir_run_273 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState262 ->
          _menhir_run_263 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState253 ->
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState055 ->
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState245 ->
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState243 ->
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState057 ->
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState239 ->
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState237 ->
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState059 ->
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState233 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState064 ->
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState227 ->
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState069 ->
          _menhir_run_222 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState219 ->
          _menhir_run_220 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState217 ->
          _menhir_run_218 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState071 ->
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState074 ->
          _menhir_run_214 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState079 ->
          _menhir_run_209 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState081 ->
          _menhir_run_207 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState083 ->
          _menhir_run_205 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState198 ->
          _menhir_run_199 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState196 ->
          _menhir_run_197 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState085 ->
          _menhir_run_195 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState192 ->
          _menhir_run_193 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState190 ->
          _menhir_run_191 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState087 ->
          _menhir_run_189 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState337 ->
          _menhir_run_183 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState184 ->
          _menhir_run_183 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState089 ->
          _menhir_run_183 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState344 ->
          _menhir_run_179 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState259 ->
          _menhir_run_179 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState090 ->
          _menhir_run_179 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState091 ->
          _menhir_run_179 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState182 ->
          _menhir_run_178 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState177 ->
          _menhir_run_178 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState096 ->
          _menhir_run_174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState098 ->
          _menhir_run_170 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState165 ->
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState100 ->
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState155 ->
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState153 ->
          _menhir_run_154 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState107 ->
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState147 ->
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState109 ->
          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState143 ->
          _menhir_run_144 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState141 ->
          _menhir_run_142 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState139 ->
          _menhir_run_140 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState137 ->
          _menhir_run_138 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState135 ->
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState133 ->
          _menhir_run_134 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState131 ->
          _menhir_run_132 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState129 ->
          _menhir_run_130 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState127 ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState125 ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState123 ->
          _menhir_run_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState121 ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState119 ->
          _menhir_run_120 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState117 ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState115 ->
          _menhir_run_116 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState111 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_472 : type  ttv_stack. (((ttv_stack, _menhir_box_macros) _menhir_cell1_NAME, _menhir_box_macros) _menhir_cell1_formals as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_macros) _menhir_state -> _ -> _menhir_box_macros =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EOF | NAME _ ->
          let MenhirCell1_formals (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_NAME (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _5 = _v in
          let _v = _menhir_action_123 _1 _3 _5 in
          _menhir_goto_macro _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_115 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState115 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMICADDUNLESS ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_117 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState117 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMICADDUNLESS ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_119 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState119 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMICADDUNLESS ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_139 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState139 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMICADDUNLESS ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_123 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState123 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMICADDUNLESS ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_127 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState127 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMICADDUNLESS ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_129 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState129 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMICADDUNLESS ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_131 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState131 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMICADDUNLESS ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_133 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState133 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMICADDUNLESS ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_135 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState135 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMICADDUNLESS ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_137 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState137 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMICADDUNLESS ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_121 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState121 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMICADDUNLESS ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_125 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState125 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMICADDUNLESS ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_goto_macro : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_macros) _menhir_state -> _ -> _menhir_box_macros =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_macro (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | NAME _v_0 ->
          _menhir_run_461 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState475
      | EOF ->
          let _v_1 = _menhir_action_116 () in
          _menhir_run_476 _menhir_stack _v_1
      | _ ->
          _eRR ()
  
  and _menhir_run_461 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_macros) _menhir_state -> _menhir_box_macros =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_NAME (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState462 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v ->
              _menhir_run_463 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | RPAR ->
              let _v = _menhir_action_079 () in
              _menhir_goto_formals _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_463 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_macros) _menhir_state -> _menhir_box_macros =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_NAME (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState464 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v ->
              _menhir_run_463 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_081 _1 in
          _menhir_goto_formals_ne _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_goto_formals_ne : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_macros) _menhir_state -> _menhir_box_macros =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState462 ->
          _menhir_run_466 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState464 ->
          _menhir_run_465 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_466 : type  ttv_stack. ((ttv_stack, _menhir_box_macros) _menhir_cell1_NAME as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_macros) _menhir_state -> _menhir_box_macros =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _1 = _v in
      let _v = _menhir_action_080 _1 in
      _menhir_goto_formals _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_formals : type  ttv_stack. ((ttv_stack, _menhir_box_macros) _menhir_cell1_NAME as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_macros) _menhir_state -> _menhir_box_macros =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_formals (_menhir_stack, _menhir_s, _v) in
      let _menhir_s = MenhirState468 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          let _menhir_stack = MenhirCell1_LBRACE (_menhir_stack, _menhir_s) in
          let _menhir_s = MenhirState469 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WHILE ->
              _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNLOCK ->
              _menhir_run_261 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERFENCE ->
              _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOP ->
              _menhir_run_271 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ST_EXPLICIT ->
              _menhir_run_280 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STORE ->
              _menhir_run_289 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_299 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_314 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINUNLOCK ->
              _menhir_run_326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINLOCK ->
              _menhir_run_331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_336 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOCK ->
              _menhir_run_349 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              _menhir_run_354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              _menhir_run_355 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FENCE ->
              _menhir_run_359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONST ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CODEVAR _v ->
              _menhir_run_364 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_TYPE _v ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_TYPE _v ->
              _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR | INT | LONG | MUTEX ->
              _menhir_reduce_171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
          | _ ->
              _eRR ())
      | EXC_EXPLICIT ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMICADDUNLESS ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_261 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_UNLOCK (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState262 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_266 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_UNDERFENCE (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          let _menhir_s = MenhirState267 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UNLOCK ->
              _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LOCK ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_271 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_UNDERATOMICOP (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState272 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_280 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_ST_EXPLICIT (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState281 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_289 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_STORE (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          let _menhir_s = MenhirState290 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UNLOCK ->
              _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LOCK ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_299 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_STAR (_menhir_stack, _menhir_s) in
          _menhir_run_300 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState299
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | ADD | DIV | EQ_OP | GE | GT | LAND | LE | LT | NEQ_OP | PIPE | SEMI | STAR | SUB | XOR ->
              let _2 = _v in
              let _v = _menhir_action_042 _2 in
              _menhir_goto_expr0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | EQ ->
              let _menhir_stack = MenhirCell1_STAR (_menhir_stack, _menhir_s) in
              let _v =
                let _1 = _v in
                _menhir_action_118 _1
              in
              _menhir_run_310 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState299 _tok
          | _ ->
              _eRR ())
      | LPAR ->
          let _menhir_stack = MenhirCell1_STAR (_menhir_stack, _menhir_s) in
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, MenhirState299) in
          let _menhir_s = MenhirState307 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONST ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_TYPE _v ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_TYPE _v ->
              _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR | INT | LONG | MUTEX ->
              _menhir_reduce_171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_300 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STAR as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_STAR (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | STAR ->
          _menhir_run_300 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState300
      | NAME _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v =
            let _1 = _v in
            _menhir_action_118 _1
          in
          _menhir_run_305 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | LPAR ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, MenhirState300) in
          let _menhir_s = MenhirState302 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_305 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STAR, ttv_result) _menhir_cell1_STAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_STAR (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_119 _2 in
      _menhir_goto_location _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_location : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState299 ->
          _menhir_run_310 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState300 ->
          _menhir_run_305 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_310 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_location (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | EQ ->
          let _menhir_s = MenhirState311 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_314 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SRCU (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          let _menhir_s = MenhirState315 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UNLOCK ->
              _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LOCK ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_326 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SPINUNLOCK (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState327 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_331 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_SPINLOCK (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState332 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_336 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_stack = MenhirCell1_NAME (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState337
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState337
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState337
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState337
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState337
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState337
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState337
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState337
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState337
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState337
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState337
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState337
          | NAME _v_0 ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState337
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState337
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState337
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState337
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState337
          | CONSTVAR _v_1 ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState337
          | CONSTANT _v_2 ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState337
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState337
          | ATOMIC_FETCH_EXPLICIT _v_3 ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState337
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState337
          | RPAR ->
              let _v_4 = _menhir_action_012 () in
              _menhir_run_338 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4
          | _ ->
              _eRR ())
      | EQ ->
          let _menhir_stack = MenhirCell1_NAME (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState341 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | ADD | DIV | EQ_OP | GE | GT | LAND | LE | LT | NEQ_OP | PIPE | SEMI | STAR | SUB | XOR ->
          let _1 = _v in
          let _v = _menhir_action_041 _1 in
          _menhir_goto_expr0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_338 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_NAME -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SEMI ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_NAME (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_109 _1 _3 in
          _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | ADD | DIV | EQ_OP | GE | GT | LAND | LE | LT | NEQ_OP | PIPE | STAR | SUB | XOR ->
          let MenhirCell1_NAME (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_067 _1 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_instruction : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_028 _1 in
      _menhir_goto_block_ins _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_block_ins : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState479 ->
          _menhir_run_392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState046 ->
          _menhir_run_392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState392 ->
          _menhir_run_392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState390 ->
          _menhir_run_392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState260 ->
          _menhir_run_387 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState469 ->
          _menhir_run_385 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState354 ->
          _menhir_run_385 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState385 ->
          _menhir_run_385 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState383 ->
          _menhir_run_385 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState376 ->
          _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState358 ->
          _menhir_run_375 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_392 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | WHILE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | WCAS_EXPLICIT ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | WCAS ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | VOLATILE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | VOID ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | UNLOCK ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_261 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | UNDERFENCE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | UNDERATOMICOPRETURN ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | UNDERATOMICOP ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_271 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | UNDERATOMICFETCHOP ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | UNDERATOMICADDUNLESS ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | ST_EXPLICIT ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_280 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | STRUCT ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | STORE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_289 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | STAR ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_299 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | SRCU ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_314 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | SPINUNLOCK ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_326 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | SPINTRYLOCK ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | SPINLOCK ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | SPINISLOCKED ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | SCAS_EXPLICIT ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | SCAS ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | NAME _v_0 ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_336 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState392
      | LPAR ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_344 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | LOCK ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_349 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | LOAD ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | LD_EXPLICIT ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | LBRACE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_354 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | IF ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_355 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | FENCE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_359 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | EXC_EXPLICIT ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | CONSTVAR _v_1 ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState392
      | CONSTANT _v_2 ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState392
      | CONST ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | CODEVAR _v_3 ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_364 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState392
      | CMPXCHG ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | BASE_TYPE _v_4 ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState392
      | ATOMIC_TYPE _v_5 ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState392
      | ATOMIC_FETCH_EXPLICIT _v_6 ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState392
      | ATOMIC_BASE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | ATOMICADDUNLESS ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | ATOMIC ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState392
      | EOF | RBRACE ->
          let _1 = _v in
          let _v = _menhir_action_033 _1 in
          _menhir_goto_do_pseudo_seq _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | CHAR | INT | LONG | MUTEX ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState392 in
          let _v = _menhir_action_171 () in
          _menhir_goto_ty_attr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_344 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState344
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState344
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState344
      | VOLATILE ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState344
      | VOID ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | RPAR ->
              let _menhir_stack = MenhirCell1_VOID (_menhir_stack, MenhirState344) in
              let _menhir_s = MenhirState346 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | XCHG ->
                  _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | WCAS_EXPLICIT ->
                  _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | WCAS ->
                  _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | UNDERATOMICOPRETURN ->
                  _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | UNDERATOMICFETCHOP ->
                  _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | UNDERATOMICADDUNLESS ->
                  _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | STAR ->
                  _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | SRCU ->
                  _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | SPINTRYLOCK ->
                  _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | SPINISLOCKED ->
                  _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | SCAS_EXPLICIT ->
                  _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | SCAS ->
                  _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | NAME _v ->
                  _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | LPAR ->
                  _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LOAD ->
                  _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LD_EXPLICIT ->
                  _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | EXC_EXPLICIT ->
                  _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | CONSTVAR _v ->
                  _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | CONSTANT _v ->
                  _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | CMPXCHG ->
                  _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | ATOMIC_FETCH_EXPLICIT _v ->
                  _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | ATOMICADDUNLESS ->
                  _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | _ ->
                  _eRR ())
          | STAR ->
              let _menhir_s = MenhirState344 in
              let _v = _menhir_action_183 () in
              _menhir_goto_void _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState344
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState344
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState344
      | STRUCT ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState344
      | STAR ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState344
      | SRCU ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState344
      | SPINTRYLOCK ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState344
      | SPINISLOCKED ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState344
      | SCAS_EXPLICIT ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState344
      | SCAS ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState344
      | NAME _v ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState344
      | LPAR ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState344
      | LOAD ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState344
      | LD_EXPLICIT ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState344
      | EXC_EXPLICIT ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState344
      | CONSTVAR _v ->
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState344
      | CONSTANT _v ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState344
      | CONST ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState344
      | CMPXCHG ->
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState344
      | BASE_TYPE _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState344
      | ATOMIC_TYPE _v ->
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState344
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState344
      | ATOMIC_BASE ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState344
      | ATOMICADDUNLESS ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState344
      | ATOMIC ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState344
      | CHAR | INT | LONG | MUTEX ->
          let _menhir_s = MenhirState344 in
          let _v = _menhir_action_171 () in
          _menhir_goto_ty_attr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_349 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LOCK (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState350 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_354 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LBRACE (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState354 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WHILE ->
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNLOCK ->
          _menhir_run_261 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERFENCE ->
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOP ->
          _menhir_run_271 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ST_EXPLICIT ->
          _menhir_run_280 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STORE ->
          _menhir_run_289 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_299 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_314 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINUNLOCK ->
          _menhir_run_326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINLOCK ->
          _menhir_run_331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_336 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOCK ->
          _menhir_run_349 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          _menhir_run_354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          _menhir_run_355 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FENCE ->
          _menhir_run_359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONST ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CODEVAR _v ->
          _menhir_run_364 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_TYPE _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_TYPE _v ->
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_BASE ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMICADDUNLESS ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR | INT | LONG | MUTEX ->
          _menhir_reduce_171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_355 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_IF (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState356 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_359 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | MEMORDER _v ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | RPAR ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | SEMI ->
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      let _3 = _v in
                      let _v = _menhir_action_107 _3 in
                      _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_364 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SEMI ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v in
          let _v = _menhir_action_108 _1 in
          _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_do_pseudo_seq : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState479 ->
          _menhir_run_481 _menhir_stack _v _tok
      | MenhirState392 ->
          _menhir_run_393 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState390 ->
          _menhir_run_391 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState046 ->
          _menhir_run_388 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_393 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_block_ins -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_block_ins (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_034 _1 _2 in
      _menhir_goto_do_pseudo_seq _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_391 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_declaration -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_declaration (_menhir_stack, _menhir_s, _) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_036 _2 in
      _menhir_goto_do_pseudo_seq _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_388 : type  ttv_stack. ((ttv_stack, _menhir_box_deep_main) _menhir_cell1_voidopt _menhir_cell0_PROC, _menhir_box_deep_main) _menhir_cell1_parameter_list -> _ -> _ -> _ -> _ -> _menhir_box_deep_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RBRACE ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_parameter_list (_menhir_stack, _, _4) = _menhir_stack in
          let MenhirCell0_PROC (_menhir_stack, _2) = _menhir_stack in
          let MenhirCell1_voidopt (_menhir_stack, _menhir_s, _) = _menhir_stack in
          let _7 = _v in
          let _v = _menhir_action_083 _2 _4 _7 in
          _menhir_goto_function_def _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_function_def : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_deep_main) _menhir_state -> _ -> _menhir_box_deep_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState000 ->
          _menhir_run_458 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState397 ->
          _menhir_run_457 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_458 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_deep_main) _menhir_state -> _ -> _menhir_box_deep_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_169 _1 in
      _menhir_goto_trans_unit _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_trans_unit : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_deep_main) _menhir_state -> _ -> _menhir_box_deep_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_trans_unit (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState397
      | SCOPES ->
          _menhir_run_398 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState397
      | REGIONS ->
          _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState397
      | LEVELS ->
          _menhir_run_427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState397
      | EOF ->
          let _menhir_s = MenhirState397 in
          let _v = _menhir_action_149 () in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
      | PROC _ ->
          let _v_1 = _menhir_action_186 () in
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState397 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_003 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_deep_main) _menhir_state -> _ -> _menhir_box_deep_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_voidopt (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | PROC _v_0 ->
          let _menhir_stack = MenhirCell0_PROC (_menhir_stack, _v_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LPAR ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VOLATILE ->
                  _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState005
              | VOID ->
                  _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState005
              | STRUCT ->
                  _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState005
              | LPAR ->
                  _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState005
              | CONST ->
                  _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState005
              | BASE_TYPE _v_1 ->
                  _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState005
              | ATOMIC_TYPE _v_2 ->
                  _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState005
              | ATOMIC_BASE ->
                  _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState005
              | ATOMIC ->
                  _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState005
              | RPAR ->
                  let _v_3 = _menhir_action_131 () in
                  _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState005
              | CHAR | INT | LONG | MUTEX ->
                  let _menhir_s = MenhirState005 in
                  let _v = _menhir_action_171 () in
                  _menhir_goto_ty_attr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_457 : type  ttv_stack. (ttv_stack, _menhir_box_deep_main) _menhir_cell1_trans_unit -> _ -> _ -> _ -> _ -> _menhir_box_deep_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_trans_unit (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_170 _1 _2 in
      _menhir_goto_trans_unit _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_387 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_WHILE, ttv_result) _menhir_cell1_expr0 -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_expr0 (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_WHILE (_menhir_stack, _menhir_s) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_092 _2 _3 in
      _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_385 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | WHILE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | WCAS_EXPLICIT ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | WCAS ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | VOLATILE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | VOID ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | UNLOCK ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_261 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | UNDERFENCE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | UNDERATOMICOPRETURN ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | UNDERATOMICOP ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_271 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | UNDERATOMICFETCHOP ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | UNDERATOMICADDUNLESS ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | ST_EXPLICIT ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_280 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | STRUCT ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | STORE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_289 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | STAR ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_299 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | SRCU ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_314 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | SPINUNLOCK ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_326 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | SPINTRYLOCK ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | SPINLOCK ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | SPINISLOCKED ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | SCAS_EXPLICIT ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | SCAS ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | NAME _v_0 ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_336 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState385
      | LPAR ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_344 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | LOCK ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_349 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | LOAD ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | LD_EXPLICIT ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | LBRACE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_354 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | IF ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_355 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | FENCE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_359 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | EXC_EXPLICIT ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | CONSTVAR _v_1 ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState385
      | CONSTANT _v_2 ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState385
      | CONST ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | CODEVAR _v_3 ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_364 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState385
      | CMPXCHG ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | BASE_TYPE _v_4 ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState385
      | ATOMIC_TYPE _v_5 ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState385
      | ATOMIC_FETCH_EXPLICIT _v_6 ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState385
      | ATOMIC_BASE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | ATOMICADDUNLESS ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | ATOMIC ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState385
      | RBRACE ->
          let _1 = _v in
          let _v = _menhir_action_086 _1 in
          _menhir_goto_ins_seq _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CHAR | INT | LONG | MUTEX ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState385 in
          let _v = _menhir_action_171 () in
          _menhir_goto_ty_attr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_ins_seq : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState469 ->
          _menhir_run_470 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState385 ->
          _menhir_run_386 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState383 ->
          _menhir_run_384 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState354 ->
          _menhir_run_381 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_470 : type  ttv_stack. (((ttv_stack, _menhir_box_macros) _menhir_cell1_NAME, _menhir_box_macros) _menhir_cell1_formals, _menhir_box_macros) _menhir_cell1_LBRACE -> _ -> _ -> _ -> _menhir_box_macros =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LBRACE (_menhir_stack, _) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_030 _2 in
      let MenhirCell1_formals (_menhir_stack, _, _3) = _menhir_stack in
      let MenhirCell1_NAME (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _5 = _v in
      let _v = _menhir_action_124 _1 _3 _5 in
      _menhir_goto_macro _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_386 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_block_ins -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_block_ins (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_087 _1 _2 in
      _menhir_goto_ins_seq _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_384 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_declaration -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_declaration (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_089 _1 _2 in
      _menhir_goto_ins_seq _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_381 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LBRACE -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LBRACE (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_029 _2 in
      _menhir_goto_block_ins _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_377 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_IF, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_block_ins -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_block_ins (_menhir_stack, _, _5) = _menhir_stack in
      let MenhirCell1_expr (_menhir_stack, _, _3) = _menhir_stack in
      let MenhirCell1_IF (_menhir_stack, _menhir_s) = _menhir_stack in
      let _7 = _v in
      let _v = _menhir_action_091 _3 _5 _7 in
      _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_375 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_IF, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | ELSE ->
          let _menhir_stack = MenhirCell1_block_ins (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState376 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WHILE ->
              _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNLOCK ->
              _menhir_run_261 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERFENCE ->
              _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOP ->
              _menhir_run_271 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ST_EXPLICIT ->
              _menhir_run_280 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STORE ->
              _menhir_run_289 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_299 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_314 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINUNLOCK ->
              _menhir_run_326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINLOCK ->
              _menhir_run_331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_336 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOCK ->
              _menhir_run_349 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              _menhir_run_354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              _menhir_run_355 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FENCE ->
              _menhir_run_359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONST ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CODEVAR _v ->
              _menhir_run_364 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_TYPE _v ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_TYPE _v ->
              _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR | INT | LONG | MUTEX ->
              _menhir_reduce_171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
          | _ ->
              _eRR ())
      | ATOMIC | ATOMICADDUNLESS | ATOMIC_BASE | ATOMIC_FETCH_EXPLICIT _ | ATOMIC_TYPE _ | BASE_TYPE _ | CHAR | CMPXCHG | CODEVAR _ | CONST | CONSTANT _ | CONSTVAR _ | EOF | EXC_EXPLICIT | FENCE | IF | INT | LBRACE | LD_EXPLICIT | LOAD | LOCK | LONG | LPAR | MUTEX | NAME _ | RBRACE | SCAS | SCAS_EXPLICIT | SPINISLOCKED | SPINLOCK | SPINTRYLOCK | SPINUNLOCK | SRCU | STAR | STORE | STRUCT | ST_EXPLICIT | UNDERATOMICADDUNLESS | UNDERATOMICFETCHOP | UNDERATOMICOP | UNDERATOMICOPRETURN | UNDERFENCE | UNLOCK | VOID | VOLATILE | WCAS | WCAS_EXPLICIT | WHILE | XCHG ->
          let MenhirCell1_expr (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_IF (_menhir_stack, _menhir_s) = _menhir_stack in
          let _5 = _v in
          let _v = _menhir_action_090 _3 _5 in
          _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_465 : type  ttv_stack. (ttv_stack, _menhir_box_macros) _menhir_cell1_NAME -> _ -> _ -> _ -> _menhir_box_macros =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_NAME (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_082 _1 _3 in
      _menhir_goto_formals_ne _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_374 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SEMI ->
          let e = _v in
          let _v = _menhir_action_078 e in
          let _1 = _v in
          let _v = _menhir_action_085 _1 in
          _menhir_goto_initialisation _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_goto_initialisation : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_093 _1 in
      _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_369 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_typ _menhir_cell0_NAME as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SEMI ->
          let MenhirCell0_NAME (_menhir_stack, _2) = _menhir_stack in
          let MenhirCell1_typ (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _4 = _v in
          let _v = _menhir_action_084 _1 _2 _4 in
          _menhir_goto_initialisation _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_357 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_IF as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _menhir_s = MenhirState358 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WHILE ->
              _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNLOCK ->
              _menhir_run_261 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERFENCE ->
              _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOP ->
              _menhir_run_271 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ST_EXPLICIT ->
              _menhir_run_280 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STORE ->
              _menhir_run_289 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_299 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_314 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINUNLOCK ->
              _menhir_run_326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINLOCK ->
              _menhir_run_331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_336 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOCK ->
              _menhir_run_349 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              _menhir_run_354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              _menhir_run_355 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FENCE ->
              _menhir_run_359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONST ->
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CODEVAR _v ->
              _menhir_run_364 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_TYPE _v ->
              _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_TYPE _v ->
              _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMIC_BASE ->
              _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR | INT | LONG | MUTEX ->
              _menhir_reduce_171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
          | _ ->
              _eRR ())
      | PIPE ->
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_351 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LOCK as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SEMI ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_LOCK (_menhir_stack, _menhir_s) = _menhir_stack in
              let _3 = _v in
              let _v = _menhir_action_101 _3 in
              _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_347 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_VOID as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SEMI ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_VOID (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _4 = _v in
          let _v = _menhir_action_095 _4 in
          _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_342 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_NAME as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SEMI ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_NAME (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_094 _1 _3 in
          _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_333 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_SPINLOCK as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SEMI ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_SPINLOCK (_menhir_stack, _menhir_s) = _menhir_stack in
              let _3 = _v in
              let _v = _menhir_action_103 _3 in
              _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_328 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_SPINUNLOCK as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SEMI ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_SPINUNLOCK (_menhir_stack, _menhir_s) = _menhir_stack in
              let _3 = _v in
              let _v = _menhir_action_104 _3 in
              _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_323 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_SRCU, ttv_result) _menhir_cell1_annot_list, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SEMI ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_expr (_menhir_stack, _, _6) = _menhir_stack in
              let MenhirCell1_annot_list (_menhir_stack, _, _3) = _menhir_stack in
              let MenhirCell1_SRCU (_menhir_stack, _menhir_s) = _menhir_stack in
              let _8 = _v in
              let _v = _menhir_action_099 _3 _6 _8 in
              _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_319 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_SRCU, ttv_result) _menhir_cell1_annot_list as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SEMI ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_annot_list (_menhir_stack, _, _3) = _menhir_stack in
              let MenhirCell1_SRCU (_menhir_stack, _menhir_s) = _menhir_stack in
              let _6 = _v in
              let _v = _menhir_action_098 _3 _6 in
              _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | ADD | DIV | EQ_OP | GE | GT | LAND | LE | LT | NEQ_OP | PIPE | STAR | SUB | XOR ->
              let MenhirCell1_annot_list (_menhir_stack, _, _3) = _menhir_stack in
              let MenhirCell1_SRCU (_menhir_stack, _menhir_s) = _menhir_stack in
              let _6 = _v in
              let _v = _menhir_action_048 _3 _6 in
              _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState322 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_312 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STAR, ttv_result) _menhir_cell1_location as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SEMI ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_location (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_STAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _4 = _v in
          let _v = _menhir_action_096 _2 _4 in
          _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_308 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STAR, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | ADD | DIV | EQ_OP | GE | GT | LAND | LE | LT | NEQ_OP | PIPE | SEMI | STAR | SUB | XOR ->
              let MenhirCell1_LPAR (_menhir_stack, _) = _menhir_stack in
              let MenhirCell1_STAR (_menhir_stack, _menhir_s) = _menhir_stack in
              let _3 = _v in
              let _v = _menhir_action_046 _3 in
              _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | EQ ->
              let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
              let _2 = _v in
              let _v = _menhir_action_120 _2 in
              _menhir_goto_location _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_303 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_STAR, ttv_result) _menhir_cell1_STAR, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _2 = _v in
          let _v = _menhir_action_120 _2 in
          _menhir_goto_location _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_296 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_STORE, ttv_result) _menhir_cell1_annot_list, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SEMI ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_expr (_menhir_stack, _, _6) = _menhir_stack in
              let MenhirCell1_annot_list (_menhir_stack, _, _3) = _menhir_stack in
              let MenhirCell1_STORE (_menhir_stack, _menhir_s) = _menhir_stack in
              let _8 = _v in
              let _v = _menhir_action_097 _3 _6 _8 in
              _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_294 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STORE, ttv_result) _menhir_cell1_annot_list as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState295 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_284 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_ST_EXPLICIT, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | MEMORDER _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | RPAR ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | SEMI ->
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      let MenhirCell1_expr (_menhir_stack, _, _3) = _menhir_stack in
                      let MenhirCell1_ST_EXPLICIT (_menhir_stack, _menhir_s) = _menhir_stack in
                      let (_5, _7) = (_v, _v_0) in
                      let _v = _menhir_action_100 _3 _5 _7 in
                      _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_282 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ST_EXPLICIT as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState283 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_277 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICOP, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_atomic_op as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SEMI ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_atomic_op (_menhir_stack, _, _5) = _menhir_stack in
              let MenhirCell1_expr (_menhir_stack, _, _3) = _menhir_stack in
              let MenhirCell1_UNDERATOMICOP (_menhir_stack, _menhir_s) = _menhir_stack in
              let _7 = _v in
              let _v = _menhir_action_106 _3 _5 _7 in
              _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_273 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICOP as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState274 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SUB ->
              _menhir_run_224 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADD ->
              _menhir_run_225 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_224 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_017 () in
      _menhir_goto_atomic_op _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_atomic_op : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState274 ->
          _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState231 ->
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState223 ->
          _menhir_run_226 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_275 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICOP, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_atomic_op (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState276 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_232 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICOPRETURN, ttv_result) _menhir_cell1_annot_list, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_atomic_op (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState233 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_226 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICFETCHOP, ttv_result) _menhir_cell1_annot_list, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_atomic_op (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState227 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_225 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_016 () in
      _menhir_goto_atomic_op _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_263 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_UNLOCK as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SEMI ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_UNLOCK (_menhir_stack, _menhir_s) = _menhir_stack in
              let _3 = _v in
              let _v = _menhir_action_102 _3 in
              _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_254 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_XCHG, ttv_result) _menhir_cell1_annot_list, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_expr (_menhir_stack, _, _6) = _menhir_stack in
          let MenhirCell1_annot_list (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_XCHG (_menhir_stack, _menhir_s) = _menhir_stack in
          let _8 = _v in
          let _v = _menhir_action_064 _3 _6 _8 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_252 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_XCHG, ttv_result) _menhir_cell1_annot_list as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState253 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_246 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_WCAS_EXPLICIT, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | MEMORDER _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | COMMA ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | MEMORDER _v_1 ->
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      (match (_tok : MenhirBasics.token) with
                      | RPAR ->
                          let _tok = _menhir_lexer _menhir_lexbuf in
                          let MenhirCell1_expr (_menhir_stack, _, _5) = _menhir_stack in
                          let MenhirCell1_expr (_menhir_stack, _, _3) = _menhir_stack in
                          let MenhirCell1_WCAS_EXPLICIT (_menhir_stack, _menhir_s) = _menhir_stack in
                          let (_7, _9, _11) = (_v, _v_0, _v_1) in
                          let _v = _menhir_action_069 _11 _3 _5 _7 _9 in
                          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
                      | _ ->
                          _eRR ())
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_244 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_WCAS_EXPLICIT, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState245 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_242 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_WCAS_EXPLICIT as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState243 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_240 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_WCAS, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_expr (_menhir_stack, _, _5) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_WCAS (_menhir_stack, _menhir_s) = _menhir_stack in
          let _7 = _v in
          let _v = _menhir_action_068 _3 _5 _7 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_238 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_WCAS, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState239 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_236 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_WCAS as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState237 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_234 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICOPRETURN, ttv_result) _menhir_cell1_annot_list, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_atomic_op as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_atomic_op (_menhir_stack, _, _8) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _, _6) = _menhir_stack in
          let MenhirCell1_annot_list (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_UNDERATOMICOPRETURN (_menhir_stack, _menhir_s) = _menhir_stack in
          let _10 = _v in
          let _v = _menhir_action_074 _10 _3 _6 _8 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_230 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICOPRETURN, ttv_result) _menhir_cell1_annot_list as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState231 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SUB ->
              _menhir_run_224 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADD ->
              _menhir_run_225 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_228 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICFETCHOP, ttv_result) _menhir_cell1_annot_list, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_atomic_op as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_atomic_op (_menhir_stack, _, _8) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _, _6) = _menhir_stack in
          let MenhirCell1_annot_list (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_UNDERATOMICFETCHOP (_menhir_stack, _menhir_s) = _menhir_stack in
          let _10 = _v in
          let _v = _menhir_action_075 _10 _3 _6 _8 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_222 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICFETCHOP, ttv_result) _menhir_cell1_annot_list as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState223 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SUB ->
              _menhir_run_224 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADD ->
              _menhir_run_225 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_220 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICADDUNLESS, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_expr (_menhir_stack, _, _5) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_UNDERATOMICADDUNLESS (_menhir_stack, _menhir_s) = _menhir_stack in
          let _7 = _v in
          let _v = _menhir_action_076 _3 _5 _7 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_218 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICADDUNLESS, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState219 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_216 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICADDUNLESS as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState217 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_214 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STAR, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_STAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_046 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_209 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_SRCU, ttv_result) _menhir_cell1_annot_list as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_annot_list (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_SRCU (_menhir_stack, _menhir_s) = _menhir_stack in
          let _6 = _v in
          let _v = _menhir_action_048 _3 _6 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_207 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_SPINTRYLOCK as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_SPINTRYLOCK (_menhir_stack, _menhir_s) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_072 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_205 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_SPINISLOCKED as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_SPINISLOCKED (_menhir_stack, _menhir_s) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_073 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_199 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_SCAS_EXPLICIT, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | MEMORDER _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | COMMA ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | MEMORDER _v_1 ->
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      (match (_tok : MenhirBasics.token) with
                      | RPAR ->
                          let _tok = _menhir_lexer _menhir_lexbuf in
                          let MenhirCell1_expr (_menhir_stack, _, _5) = _menhir_stack in
                          let MenhirCell1_expr (_menhir_stack, _, _3) = _menhir_stack in
                          let MenhirCell1_SCAS_EXPLICIT (_menhir_stack, _menhir_s) = _menhir_stack in
                          let (_7, _9, _11) = (_v, _v_0, _v_1) in
                          let _v = _menhir_action_071 _11 _3 _5 _7 _9 in
                          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
                      | _ ->
                          _eRR ())
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_197 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_SCAS_EXPLICIT, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState198 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_195 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_SCAS_EXPLICIT as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState196 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_193 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_SCAS, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_expr (_menhir_stack, _, _5) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_SCAS (_menhir_stack, _menhir_s) = _menhir_stack in
          let _7 = _v in
          let _v = _menhir_action_070 _3 _5 _7 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_191 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_SCAS, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState192 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_189 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_SCAS as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState190 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_183 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState184 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_014 _1 in
          _menhir_goto_args_ne _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_goto_args_ne : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState337 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState089 ->
          _menhir_run_186 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState184 ->
          _menhir_run_185 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_186 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_NAME as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _1 = _v in
      let _v = _menhir_action_013 _1 in
      _menhir_goto_args _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_args : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_NAME as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState337 ->
          _menhir_run_338 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState089 ->
          _menhir_run_187 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_185 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_expr (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_015 _1 _3 in
      _menhir_goto_args_ne _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_179 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _2 = _v in
          let _v = _menhir_action_043 _2 in
          _menhir_goto_expr0 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_178 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_typ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_typ (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
      let e = _v in
      let _v = _menhir_action_044 e in
      _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_174 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LOAD, ttv_result) _menhir_cell1_annot_list as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_annot_list (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_LOAD (_menhir_stack, _menhir_s) = _menhir_stack in
          let _6 = _v in
          let _v = _menhir_action_047 _3 _6 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_170 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LD_EXPLICIT as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | MEMORDER _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | RPAR ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let MenhirCell1_LD_EXPLICIT (_menhir_stack, _menhir_s) = _menhir_stack in
                  let (_3, _5) = (_v, _v_0) in
                  let _v = _menhir_action_049 _3 _5 in
                  _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_166 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_EXC_EXPLICIT, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | MEMORDER _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | RPAR ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let MenhirCell1_expr (_menhir_stack, _, _3) = _menhir_stack in
                  let MenhirCell1_EXC_EXPLICIT (_menhir_stack, _menhir_s) = _menhir_stack in
                  let (_5, _7) = (_v, _v_0) in
                  let _v = _menhir_action_063 _3 _5 _7 in
                  _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_164 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_EXC_EXPLICIT as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState165 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_156 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_CMPXCHG, ttv_result) _menhir_cell1_annot_list, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_expr (_menhir_stack, _, _8) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _, _6) = _menhir_stack in
          let MenhirCell1_annot_list (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_CMPXCHG (_menhir_stack, _menhir_s) = _menhir_stack in
          let _10 = _v in
          let _v = _menhir_action_065 _10 _3 _6 _8 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_154 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_CMPXCHG, ttv_result) _menhir_cell1_annot_list, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState155 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_152 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_CMPXCHG, ttv_result) _menhir_cell1_annot_list as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState153 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_148 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_ATOMIC_FETCH_EXPLICIT, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | MEMORDER _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | RPAR ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let MenhirCell1_expr (_menhir_stack, _, _3) = _menhir_stack in
                  let MenhirCell1_ATOMIC_FETCH_EXPLICIT (_menhir_stack, _menhir_s, _1) = _menhir_stack in
                  let (_5, _7) = (_v, _v_0) in
                  let _v = _menhir_action_066 _1 _3 _5 _7 in
                  _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_146 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ATOMIC_FETCH_EXPLICIT as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState147 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_144 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_ATOMICADDUNLESS, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_expr (_menhir_stack, _, _5) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_ATOMICADDUNLESS (_menhir_stack, _menhir_s) = _menhir_stack in
          let _7 = _v in
          let _v = _menhir_action_077 _3 _5 _7 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | PIPE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_142 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_ATOMICADDUNLESS, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState143 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_140 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XOR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | EOF | NAME _ | PIPE | RPAR | SEMI ->
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_055 _1 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_138 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | EOF | LAND | NAME _ | PIPE | RPAR | SEMI | XOR ->
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_057 _1 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_136 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | EOF | LAND | NAME _ | PIPE | RPAR | SEMI | XOR ->
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_062 _1 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_134 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | EOF | LAND | NAME _ | PIPE | RPAR | SEMI | XOR ->
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_060 _1 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_132 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | EOF | LAND | NAME _ | PIPE | RPAR | SEMI | XOR ->
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_054 _1 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_130 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | EOF | LAND | NAME _ | PIPE | RPAR | SEMI | XOR ->
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_061 _1 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_128 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | EOF | LAND | NAME _ | PIPE | RPAR | SEMI | XOR ->
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_059 _1 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_126 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD | COMMA | EOF | EQ_OP | GE | GT | LAND | LE | LT | NAME _ | NEQ_OP | PIPE | RPAR | SEMI | SUB | XOR ->
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_051 _1 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_124 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | EOF | LAND | NAME _ | PIPE | RPAR | SEMI | XOR ->
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_058 _1 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_122 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_expr (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_053 _1 _3 in
      _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_120 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_expr -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_expr (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_050 _1 _3 in
      _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_118 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD | COMMA | EOF | EQ_OP | GE | GT | LAND | LE | LT | NAME _ | NEQ_OP | PIPE | RPAR | SEMI | SUB | XOR ->
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_052 _1 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_116 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | SUB ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADD ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | EOF | NAME _ | PIPE | RPAR | SEMI | XOR ->
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_056 _1 _3 in
          _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_114 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ATOMICADDUNLESS as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | XOR ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SUB ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer
      | STAR ->
          _menhir_run_119 _menhir_stack _menhir_lexbuf _menhir_lexer
      | PIPE ->
          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NEQ_OP ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LT ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LE ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LAND ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GT ->
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer
      | GE ->
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQ_OP ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DIV ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA ->
          let _menhir_s = MenhirState141 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | ADD ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_113 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_037 _1 in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_291 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STORE as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_annot_list (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState293 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_268 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_UNDERFENCE -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SEMI ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_UNDERFENCE (_menhir_stack, _menhir_s) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_105 _3 in
          _menhir_goto_instruction _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_163 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_annot -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_annot (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_010 _1 _3 in
      _menhir_goto_annot_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_105 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_CMPXCHG as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_annot_list (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState107 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_094 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LOAD as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_annot_list (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState096 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_077 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_SRCU as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_annot_list (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState079 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_067 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICFETCHOP as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_annot_list (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState069 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_062 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_UNDERATOMICOPRETURN as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_annot_list (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState064 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_053 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_XCHG as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_annot_list (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_s = MenhirState055 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_160 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_annot_base -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_annot_base (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_005 _1 _3 in
      _menhir_goto_annot _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_030 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_172 _1 in
      _menhir_goto_typ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_declaration : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState479 ->
          _menhir_run_390 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState392 ->
          _menhir_run_390 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState390 ->
          _menhir_run_390 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState046 ->
          _menhir_run_390 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState469 ->
          _menhir_run_383 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState385 ->
          _menhir_run_383 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState383 ->
          _menhir_run_383 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState354 ->
          _menhir_run_383 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_390 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | WHILE ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | WCAS_EXPLICIT ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | WCAS ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | VOLATILE ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | VOID ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | UNLOCK ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_261 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | UNDERFENCE ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | UNDERATOMICOPRETURN ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | UNDERATOMICOP ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_271 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | UNDERATOMICFETCHOP ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | UNDERATOMICADDUNLESS ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | ST_EXPLICIT ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_280 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | STRUCT ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | STORE ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_289 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | STAR ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_299 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | SRCU ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_314 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | SPINUNLOCK ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_326 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | SPINTRYLOCK ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | SPINLOCK ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | SPINISLOCKED ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | SCAS_EXPLICIT ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | SCAS ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | NAME _v_0 ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_336 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState390
      | LPAR ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_344 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | LOCK ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_349 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | LOAD ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | LD_EXPLICIT ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | LBRACE ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_354 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | IF ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_355 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | FENCE ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_359 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | EXC_EXPLICIT ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | CONSTVAR _v_1 ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState390
      | CONSTANT _v_2 ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState390
      | CONST ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | CODEVAR _v_3 ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_364 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState390
      | CMPXCHG ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | BASE_TYPE _v_4 ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState390
      | ATOMIC_TYPE _v_5 ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState390
      | ATOMIC_FETCH_EXPLICIT _v_6 ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState390
      | ATOMIC_BASE ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | ATOMICADDUNLESS ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | ATOMIC ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | EOF | RBRACE ->
          let _v = _menhir_action_035 () in
          _menhir_goto_do_pseudo_seq _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | CHAR | INT | LONG | MUTEX ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState390 in
          let _v = _menhir_action_171 () in
          _menhir_goto_ty_attr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_383 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | WHILE ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | WCAS_EXPLICIT ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | WCAS ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | VOLATILE ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | VOID ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | UNLOCK ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_261 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | UNDERFENCE ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | UNDERATOMICOPRETURN ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | UNDERATOMICOP ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_271 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | UNDERATOMICFETCHOP ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | UNDERATOMICADDUNLESS ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | ST_EXPLICIT ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_280 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | STRUCT ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | STORE ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_289 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | STAR ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_299 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | SRCU ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_314 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | SPINUNLOCK ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_326 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | SPINTRYLOCK ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | SPINLOCK ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | SPINISLOCKED ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | SCAS_EXPLICIT ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | SCAS ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | NAME _v_0 ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_336 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState383
      | LPAR ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_344 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | LOCK ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_349 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | LOAD ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | LD_EXPLICIT ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | LBRACE ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_354 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | IF ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_355 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | FENCE ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_359 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | EXC_EXPLICIT ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | CONSTVAR _v_1 ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState383
      | CONSTANT _v_2 ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState383
      | CONST ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | CODEVAR _v_3 ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_364 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState383
      | CMPXCHG ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | BASE_TYPE _v_4 ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState383
      | ATOMIC_TYPE _v_5 ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState383
      | ATOMIC_FETCH_EXPLICIT _v_6 ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState383
      | ATOMIC_BASE ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | ATOMICADDUNLESS ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | ATOMIC ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState383
      | RBRACE ->
          let _1 = _v in
          let _v = _menhir_action_088 _1 in
          _menhir_goto_ins_seq _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CHAR | INT | LONG | MUTEX ->
          let _menhir_stack = MenhirCell1_declaration (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState383 in
          let _v = _menhir_action_171 () in
          _menhir_goto_ty_attr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_368 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_typ _menhir_cell0_NAME -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState368 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMICADDUNLESS ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_goto_typ_par : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | VOLATILE ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v in
          let _v = _menhir_action_173 _1 in
          _menhir_goto_typ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | CONST ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v in
          let _v = _menhir_action_174 _1 in
          _menhir_goto_typ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_366 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer
      | NAME _v_0 ->
          let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
          let _menhir_stack = MenhirCell0_NAME (_menhir_stack, _v_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | EQ ->
              _menhir_run_368 _menhir_stack _menhir_lexbuf _menhir_lexer
          | _ ->
              _eRR ())
      | CONST | VOLATILE ->
          let t = _v in
          let _v = _menhir_action_179 t in
          _menhir_goto_typ_par _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_211 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_STAR, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | NAME _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_LPAR (_menhir_stack, _) = _menhir_stack in
              let MenhirCell1_STAR (_menhir_stack, _menhir_s) = _menhir_stack in
              let _5 = _v_0 in
              let _v = _menhir_action_045 _5 in
              _menhir_goto_expr1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | CONST | VOLATILE ->
          let t = _v in
          let _v = _menhir_action_179 t in
          _menhir_goto_typ_par _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_181 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState182 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS_EXPLICIT ->
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | WCAS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICOPRETURN ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICFETCHOP ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNDERATOMICADDUNLESS ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SRCU ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINTRYLOCK ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SPINISLOCKED ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS_EXPLICIT ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SCAS ->
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NAME _v ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAR ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOAD ->
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LD_EXPLICIT ->
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXC_EXPLICIT ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONSTVAR _v ->
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CONSTANT _v ->
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | CMPXCHG ->
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ATOMIC_FETCH_EXPLICIT _v ->
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ATOMICADDUNLESS ->
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | CONST | VOLATILE ->
          let t = _v in
          let _v = _menhir_action_179 t in
          _menhir_goto_typ_par _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_176 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | XCHG ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState177
          | WCAS_EXPLICIT ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState177
          | WCAS ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState177
          | UNDERATOMICOPRETURN ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState177
          | UNDERATOMICFETCHOP ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState177
          | UNDERATOMICADDUNLESS ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState177
          | STAR ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState177
          | SRCU ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState177
          | SPINTRYLOCK ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState177
          | SPINISLOCKED ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState177
          | SCAS_EXPLICIT ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState177
          | SCAS ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState177
          | NAME _v_0 ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState177
          | LPAR ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState177
          | LOAD ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState177
          | LD_EXPLICIT ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState177
          | EXC_EXPLICIT ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState177
          | CONSTVAR _v_1 ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState177
          | CONSTANT _v_2 ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState177
          | CMPXCHG ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState177
          | ATOMIC_FETCH_EXPLICIT _v_3 ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState177
          | ATOMICADDUNLESS ->
              let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState177
          | CONST | VOLATILE ->
              let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
              let t = _v in
              let _v = _menhir_action_180 t in
              _menhir_goto_typ_par _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | CONST | VOLATILE ->
          let t = _v in
          let _v = _menhir_action_179 t in
          _menhir_goto_typ_par _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_043 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer
      | CONST | VOLATILE ->
          let t = _v in
          let _v = _menhir_action_179 t in
          _menhir_goto_typ_par _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_038 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let _2 = _v in
          let _v = _menhir_action_019 _2 in
          _menhir_goto_base _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | CONST | VOLATILE ->
          let t = _v in
          let _v = _menhir_action_179 t in
          _menhir_goto_typ_par _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_base : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState006 ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState026 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState012 ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_040 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VOLATILE -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_VOLATILE (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_176 _2 in
      _menhir_goto_typ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_027 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ATOMIC -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_ATOMIC (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_175 _2 in
      _menhir_goto_typ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_025 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_CONST -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_CONST (_menhir_stack, _menhir_s) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_177 _2 in
      _menhir_goto_typ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_034 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_typ (_menhir_stack, _menhir_s, _v) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s) = _menhir_stack in
          let t = _v in
          let _v = _menhir_action_180 t in
          _menhir_goto_typ_par _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | CONST | VOLATILE ->
          let t = _v in
          let _v = _menhir_action_179 t in
          _menhir_goto_typ_par _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_024 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_018 _1 in
      _menhir_goto_base _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  let _menhir_run_000 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_deep_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState000
      | PROC _ ->
          let _v = _menhir_action_186 () in
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState000 _tok
      | _ ->
          _eRR ()
  
  let _menhir_run_460 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_macros =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | NAME _v ->
          _menhir_run_461 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState460
      | EOF ->
          let _v = _menhir_action_116 () in
          _menhir_run_477 _menhir_stack _v
      | _ ->
          _eRR ()
  
  let _menhir_run_479 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_pseudo_seq =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState479 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | XCHG ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WHILE ->
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS_EXPLICIT ->
          _menhir_run_056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | WCAS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          _menhir_run_006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNLOCK ->
          _menhir_run_261 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERFENCE ->
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOPRETURN ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICOP ->
          _menhir_run_271 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICFETCHOP ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNDERATOMICADDUNLESS ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ST_EXPLICIT ->
          _menhir_run_280 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STORE ->
          _menhir_run_289 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          _menhir_run_299 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SRCU ->
          _menhir_run_314 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINUNLOCK ->
          _menhir_run_326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINTRYLOCK ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINLOCK ->
          _menhir_run_331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SPINISLOCKED ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS_EXPLICIT ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SCAS ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NAME _v ->
          _menhir_run_336 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAR ->
          _menhir_run_344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOCK ->
          _menhir_run_349 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOAD ->
          _menhir_run_092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LD_EXPLICIT ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          _menhir_run_354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          _menhir_run_355 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FENCE ->
          _menhir_run_359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXC_EXPLICIT ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONSTVAR _v ->
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONSTANT _v ->
          _menhir_run_102 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CONST ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CODEVAR _v ->
          _menhir_run_364 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | CMPXCHG ->
          _menhir_run_103 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_TYPE _v ->
          _menhir_run_013 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_TYPE _v ->
          _menhir_run_014 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_FETCH_EXPLICIT _v ->
          _menhir_run_108 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ATOMIC_BASE ->
          _menhir_run_015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMICADDUNLESS ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ATOMIC ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR | INT | LONG | MUTEX ->
          _menhir_reduce_171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
      | _ ->
          _eRR ()
  
  let _menhir_run_483 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_shallow_main =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState483
      | SCOPES ->
          _menhir_run_398 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState483
      | REGIONS ->
          _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState483
      | LEVELS ->
          _menhir_run_427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState483
      | BODY _v ->
          _menhir_run_484 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState483
      | EOF ->
          let _menhir_s = MenhirState483 in
          let _v = _menhir_action_149 () in
          _menhir_goto_permut_scopes_key_levels_key_memory_map_key_ _menhir_stack _v _menhir_s _tok
      | PROC _ ->
          let _v = _menhir_action_186 () in
          _menhir_run_485 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState483 _tok
      | _ ->
          _eRR ()
  
end

let shallow_main =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_shallow_main v = _menhir_run_483 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let pseudo_seq =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_pseudo_seq v = _menhir_run_479 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let macros =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_macros v = _menhir_run_460 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let deep_main =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_deep_main v = _menhir_run_000 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v
